<?php
namespace HCM\AVL\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class QuestModeloRepository {

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->questPadrAval = Repositories::QUESTPADRAVAL;
        $this->questao = Repositories::QUESTAO;
        $this->reposta = Repositories::RESPOSTA;
        $this->combinacao = Repositories::COMBQUESTPADR;
        $this->agrupamento = Repositories::AGRUPQUESTPADR;
        //$this->relacionamento = Repositories::RELACQUESTPADR;
    }
    

    public function getQuestoes($comb,$agrup,$nivel,$tema,$ordem,$nrorg,$padraval)
    {
        $where = "AND r.nrpadravaliacao = ".$padraval;
        if(!is_null($comb)){
            $where .= " AND r.nrcombquestpadr = ".$comb;
        }
        if(!is_null($agrup)){
            $where .= " AND r.nragrupquestpad = ".$agrup;
        }
        if(!is_null($nivel)){
            $where .= " AND r.nrnivelquestao = ".$nivel;
        }
        if(!is_null($tema)){
            $where .= " AND r.nrtemaanalise = ".$tema;
        }
        if(!is_null($ordem)){
            $where .= " AND r.nrordequestpadr = ".$ordem;
        }
        $sql = $this->entityManager->getConnection()->prepare(
           " SELECT r.nrquestao
           FROM QUESTPADRAVAL r
            WHERE r.nrorg = :P_NRORG ".$where
    );
        $sql->execute(array(
            'P_NRORG' => $nrorg
        ));


        return ($sql->fetchAll());
    }
    
    public function getQuestaoSorteio($nrorg,$nivel,$idSorteio,$nrpadravaliacao){
        
        $where = '';
        if($nivel !== '' && $nivel !== NULL){
            $where .= ' AND r.nrnivelpadquest = '.$nivel;
        }
        if($idSorteio == 'FECHADA'){
            $where .= " AND r.idtipoquestao = 'FECHADA'";
        }else{
            $where .= " AND (r.idtipoquestao = 'ABERTA_TEXTO' OR r.idtipoquestao = 'ABERTA_VALOR' OR r.idtipoquestao = 'ABERTA_DATA')";
        }
        
        $sql = $this->entityManager->getConnection()->prepare("
            SELECT r.nrquestao
            FROM QUESTAO r
            WHERE r.nrorg = :P_NRORG ".$where."AND r.nrquestao NOT IN (SELECT NRQUESTAO FROM QUESTPADRAVAL q WHERE q.nrorg = r.nrorg AND q.nrpadravaliacao = :P_NRPADRAVALIACAO) "
        );
        $sql->execute(array(
            'P_NRORG' => $nrorg,
            'P_NRPADRAVALIACAO' => $nrpadravaliacao
        ));
        $resultado = $sql->fetchAll();
        if(empty($resultado))
            return null;
        $resultado_rand = array_rand($resultado);
        return $resultado[$resultado_rand]['nrquestao'];
    
    }
    
    public function questaoExists($nrorg,$padraval){
        
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT r.NRQUESTAO
            FROM QUESTPADRAVAL r
            WHERE r.NRORG = :P_NRORG
            AND r.NRPADRAVALIACAO = :P_PADRAVAL");
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_PADRAVAL' => $padraval
            )
        );
        
        return !empty($sql->fetchAll());
    }
    
    public function agrupExists($nrorg,$padraval){
        
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT r.nragrupquestpad
            FROM AGRUPQUESTPADR r
            WHERE r.nrorg = :P_NRORG
            AND r.nrpadravaliacao = :P_PADRAVAL
");
        $sql->execute(
        array(
            'P_NRORG' => $nrorg,
            'P_PADRAVAL' => $padraval
        )
        );
        return !empty($sql->fetchAll());
    
    }
    
    public function combExists($nrorg,$padraval){
        $sql = $this->entityManager->getConnection()->prepare("
            SELECT r.nrcombquestpadr
            FROM COMBQUESTPADR r
            WHERE r.nrorg = :P_NRORG
            AND r.nrpadravaliacao = :P_PADRAVAL
");
        $sql->execute(
            array(
            'P_NRORG' => $nrorg,
            'P_PADRAVAL' => $padraval
            )
        );

        return !empty($sql->fetchAll());
    }
    
        public function combPadraoExists($nrorg){
        $sql = $this->entityManager->getConnection()->prepare("
            SELECT r.nrcombquestpadr
            FROM COMBQUESTPADR r
            WHERE r.nrorg = :P_NRORG
            AND r.nrpadravaliacao IS NULL
");
        $sql->execute(
            array(
            'P_NRORG' => $nrorg
            )
        );
        
        return empty($sql->fetchAll());
    }
    
    public function relacExists($nrorg,$padraval){
        
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT r.NRTIPORELACPADR
            FROM TIPORELACPADR r
            WHERE r.NRORG = :P_NRORG
            AND r.NRPADRAVALIACAO = :P_PADRAVAL");
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_PADRAVAL' => $padraval
            )
        );
        
        return !empty($sql->fetchAll());
    }
    
    public function respExists($nrorg,$nrquestao,$dsResposta){
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT r.NRRESPOSTA
            FROM RESPOSTA r
            WHERE r.NRORG = :P_NRORG
            AND r.DSRESPOSTA = :P_DSRESPOSTA
            AND r.NRQUESTAO = :P_NRQUESTAO
            ");
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_DSRESPOSTA' => $dsResposta,
                'P_NRQUESTAO' => $nrquestao
            )
        );
        
        return !empty($sql->fetchAll());
    }
    
    public function getResposta($nrorg,$nrquestao,$dsResposta){
        return $this->entityManager->getRepository('Teknisa\Model\Avaliacao\Entities\Resposta')->findBy(array('nrorg' => $nrorg,'nrquestao' => $nrquestao,'dsresposta' => $dsResposta));
    }

    
    public function relacIsValid($nrorg,$padraval,$nrtiporelaciona,$isnew,$codigo){
        $where = "";
        if(!$isnew){
            $where = " AND r.NRTIPORELACPADR != ".$codigo;
        }
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT r.NRTIPORELACPADR
            FROM TIPORELACPADR r
            WHERE r.NRORG = :P_NRORG
            AND r.NRPADRAVALIACAO = :P_PADRAVAL
            AND r.NRTIPORELACIONA = :P_RELACIONA".$where);
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_PADRAVAL' => $padraval,
                'P_RELACIONA' => $nrtiporelaciona
            )
        );
        
        return empty($sql->fetchAll());
    }
    

    
} 
