<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Calculos\Geral\MemoriaCalculo;
use HCM\FPA\Entity\FpafaixatabelaEntity;
use HCM\FPA\Entity\FpatabelafolhaEntity;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpaPtregraEntity;

class FGTS {

    public static function calcula(
         $incidencia, $evento, $evento_base, $mes_competencia, $item_de_calculo,
         $assoc_eventos, $eventom, $percentual,  $nrOrg
    ){
        $base = $item_de_calculo->calculaIncidencias($incidencia, $mes_competencia, $eventom);
        
        $nrevento = $assoc_eventos->retornaEvento($evento_base, $nrOrg);
        $evento_base_fgts = $eventom->retornaEvento($nrevento);

        $calculoEvento = 'Valor = '.$base.' (Base)';
        MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_base_fgts,$calculoEvento,$mes_competencia,$base,0,null,$base,$incidencia,100);
        $item_de_calculo->geraEvento($evento_base_fgts, null, $base, 0, 1);

        $indice = $item_de_calculo->procuraEvento($evento_base_fgts, null);
        if ($indice !== -1) {
            $base = $item_de_calculo->retornaValor($indice);
        } else {
            $base = 0;
        }

        $fgts = ($base * $percentual) / 100;
        $calculoEvento = '('.$base.' * '.$percentual.') / 100 = '.$fgts;

        $nrevento =  $assoc_eventos->retornaEvento($evento, $nrOrg);
        $evento_fgts = $eventom->retornaEvento($nrevento);
        
        MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_fgts,$calculoEvento,$mes_competencia,$fgts,$percentual,null,$base,$incidencia,100);
        $item_de_calculo->geraEvento($evento_fgts, null, (float)$fgts, $percentual, 1);
    }

    public static function calculoIndenizacao(
        $itemCalculo, $percentual, $assocEvento,
        $eventom, $tpAssocFGTSBanco, $tpAssocIndBanco, $nrOrg
    ){
        $nrEventoBanco = $assocEvento->retornaEvento($tpAssocFGTSBanco, $nrOrg);
        $evento = $eventom->retornaEvento($nrEventoBanco);
        $indice = $itemCalculo->procuraEvento($evento);

        if ($indice > -1) {
            $base = $itemCalculo->retornaValor($indice);
            $fgtsIndenizacao = ($base*$percentual)/100;
            $calculoEvento = '('.$base.' * '.$percentual.') / 100 = '.$fgtsIndenizacao;
            $nrEventoInd = $assocEvento->retornaEvento($tpAssocIndBanco, $nrOrg);
            $eventoInd = $eventom->retornaEvento($nrEventoInd);

            MemoriaCalculo::getInstance()->escreveEventos($itemCalculo->getNrcalculofolha(),$eventoInd,$calculoEvento,null,$fgtsIndenizacao,$percentual,null,$base,null,100);
            $itemCalculo->geraEvento($eventoInd, null, $fgtsIndenizacao, $percentual, 1);
        }
    }
}