<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\DateUtil;

class FpaValorreferenciamEntity extends TkEntity
{

    const SALARIO_MINIMO = 'SALARIO_MINIMO';
    const FGTS = 'FGTS';
    const FGTS_RESC_MULTA = 'FGTS_RESC_MULTA';
    const FGTS_RESC_MULTA_ACORDO = 'FGTS_RESC_MULTA_ACORDO';
    const VR_DEDUCAO_DEP_IR = 'VR_DEDUCAO_DEP_IR';
    const VR_RECOLHIMENTO_MIN_IR = 'VR_RECOLHIMENTO_MIN_IR';
    const CONTRIB_SOC_RESC = 'CONTRIB_SOC_RESC';
    const PERCENTUAL_INSS_AUTONOMO = 'PERCENTUAL_INSS_AUTONOMO';
    const GERA_GRRF_COMPLEMENTAR = 'GERA_GRRF_COMPLEMENTAR';
    const AVISO_TRAB_INDEN_GRRF = 'AVISO_TRAB_INDEN_GRRF';
    const FERIAS_SEMPRE_30 = 'FERIAS_SEMPRE_30';
    const ID_TRUNCA_DIGITO_3 = 'ID_TRUNCA_DIGITO_3';
    const ZIP_DEMONSTRATIVO = 'ZIP_DEMONSTRATIVO';
    const DIAS_AFAST_PERDA_AVISO = 'DIAS_AFAST_PERDA_AVISO';
    const INIVALID_NOVO_INSS = 'INIVALID_NOVO_INSS';
    const GERA_EVEN_REL_MP936 = 'GERA_EVEN_REL_MP936';

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;
    
    public function __construct($entityManager, $hcmParameters){
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $hcmParameters->getDtCompetencia();
        parent::__construct(null, $entityManager);
    }

    public function carregaValorReferencia(){

        $valorReferenciam = Repositories::FPA_VALORREFERENCIAM;
        $resultados = $this->entityManager->getRepository($valorReferenciam)->retornaValorReferencia($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);
        foreach ($resultados as $key => $valor) {
            if($valor instanceof $valorReferenciam){
                $valor->historico = $resultados[$key+1];
                $this->addItem($valor, $valor->getDsreferencia());
            }
        }
    }

    public function getValorReferencia($referencia){

        $itens = $this->getItems();

        if (count($itens) === 0) {
            $this->carregaValorReferencia();
            $itens = $this->getItems();
        }
        if (count($itens) === 0) {
            return 0;
        } else{
            if (array_key_exists($referencia,$itens)){
                $item = $itens[$referencia];
                if(!is_object($item->historico)){
                    return 0;
                }
                else{
                    return $item->historico->getVrreferencia();
                }
            } else{
                return 0;
            }
        }
    }


    public function getReferencia($referencia){

        $itens = $this->getItems();

        if (count($itens) === 0) {
            $this->carregaValorReferencia();
            $itens = $this->getItems();
        }
        $item = $itens[$referencia];
        return $item->historico->getVrrefvalorref();
    }


    public function getDescricaoReferencia($nrValorReferencia){
        $itens = $this->getItems();

        if (count($itens) === 0) {
            $this->carregaValorReferencia();
            $itens = $this->getItems();
        }
        foreach ($itens as $item){
            if ($item->getNrvalorreferenciam() === $nrValorReferencia){
                return $item->getDsreferencia();
            }
        }

    }

}

