<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Geral\Services\HcmServices;
use Teknisa\Model\Gestaopessoas\Entities\GpePessoa;
use Teknisa\Model\Gestaopessoas\Entities\GpeVinculom;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class RelatCustomIntegraFinanService {
    /** @var EntityManager */
    protected $entityManager;

    /** @var HCMParameters */
    protected $hcmParameters;

    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        EntityManager $entityManager,
        HCMParameters $hcmParameters,
        HcmServices   $hcmServices
    ) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->hcmServices   = $hcmServices;
    }

    public function getRelatCustomIntegraFinan(array $row): array {
        $route = 'retornaPagamentosPorCnpjDataMovimento';
        $nrOrg = $this->hcmParameters->getNrorgTrabalho();
        
        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];
        
        return $this->hcmServices->send($route, $params, $nrOrg, 'POST', false);
    }
}