<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;
use HCM\Util\Repositories;


class AlteEscalaRepository {

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function retornaUltimaAlteEscalaPorDataInicio($nrorg, $nrvinculom, $dtiniescala)
    {
        try {
            $query = <<<SQL
SELECT *
  FROM GPE_ALTEESCALA
 WHERE NRORG = :P_NRORG
   AND NRVINCULOM = :P_VINCULOM
   AND DTINIESCALA = ( SELECT MAX(DTINIESCALA)
                         FROM GPE_ALTEESCALA B
                        WHERE B.NRORG = :P_NRORG
                          AND B.NRVINCULOM = :P_VINCULOM
                          AND B.DTINIESCALA <= :P_DTINIESCALA )
SQL;
            $params = array(
                'P_NRORG'       => $nrorg,
                'P_VINCULOM'    => $nrvinculom,
                'P_DTINIESCALA' => $dtiniescala,
            );
            return $this->connection->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function retornaProximaAlteEscala($nrorg, $nrvinculom, $dtiniescala) {

        $params = array($nrorg, $nrvinculom, $dtiniescala);

        $query = <<<SQL
SELECT *
  FROM GPE_ALTEESCALA
 WHERE NRORG       = ?
   AND NRVINCULOM  = ?
   AND DTINIESCALA = (SELECT MIN(DTINIESCALA)
                        FROM GPE_ALTEESCALA B
                       WHERE B.NRORG       = GPE_ALTEESCALA.NRORG
                         AND B.NRVINCULOM  = GPE_ALTEESCALA.NRVINCULOM
                         AND B.DTINIESCALA > TO_DATE(?, 'DD/MM/YYYY'))
SQL;
        return $this->connection->fetchAll($query, $params);
    }

} 
