<?php

namespace HCM\PTO\Logic\AFD;

/**
 * Rodape do arquivo AFD
 * 
 * 
 */

abstract class Rodape implements Geravel {
    /** @var ContadorRegistros */
    private $contador;
    
    public function __construct(ContadorRegistros $contador) {
        $this->contador = $contador;
    }
    
    /**
     * Responsavel por gerar o conteudo do rodape
     * @return string
     */
    public abstract function geraConteudo(): string;
    
    /**
     * Retorna a instancia de contador
     * @return ContadorRegistros
     */
    public function getContador(): ContadorRegistros {
        return $this->contador;
    }
}