-- ============================================================
-- Table: FPA_PROCINCIDEVENTO
-- ============================================================
CREATE TABLE FPA_PROCINCIDEVENTO
(
    NRORG                 NUMBER            NOT NULL,
    NRPROCINCIDEVENTO    NUMBER            NOT NULL,
    NREVENTOM            NUMBER            NOT NULL,
    NRPROCESSADMJUD        NUMBER            NOT NULL,
    NRTIPOMOVIMENT        NUMBER            NOT NULL,
    NRINCIDCP            NUMBER            NULL,
    NRINCIDIRRF            NUMBER            NULL,
    NRINCIDFGTS            NUMBER            NULL,
    IDATIVO                VARCHAR2(1)        DEFAULT 'S' NOT NULL
        CONSTRAINT CKC_IDATIVO_PROINCEVE CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU            DATE            NULL,
    NRORGINCLUSAO        NUMBER(22)        DEFAULT 1 NULL ,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL ,
    NRORGULTATU            NUMBER(22)        DEFAULT 1 NULL ,
    CDOPERULTATU        VARCHAR2(12)    DEFAULT '1' NULL ,
    CONSTRAINT PK_FPA_PROCINCIDEVENTO PRIMARY KEY (NRORG, NRPROCINCIDEVENTO),
    CONSTRAINT FK_PROINCEVE_EVENT FOREIGN KEY (NREVENTOM) REFERENCES FPA_EVENTOM (NREVENTOM),
    CONSTRAINT FK_PROINCEVE_PROCE FOREIGN KEY (NRORG, NRPROCESSADMJUD) REFERENCES GPE_PROCESSADMJUD (NRORG, NRPROCESSADMJUD),
    CONSTRAINT FK_PROINCEVE_TMOVI FOREIGN KEY (NRTIPOMOVIMENT) REFERENCES FPA_TIPOMOVIMENT (NRTIPOMOVIMENT),
    CONSTRAINT FK_PROINCEVE_INCCP FOREIGN KEY (NRINCIDCP) REFERENCES INCIDENCIACP (NRINCIDCP),
    CONSTRAINT FK_PROINCEVE_INCIRRF FOREIGN KEY (NRINCIDIRRF) REFERENCES INCIDENCIAIRRF (NRINCIDIRRF),
    CONSTRAINT FK_PROINCEVE_INCFGTS FOREIGN KEY (NRINCIDFGTS) REFERENCES INCIDENCIAFGTS (NRINCIDFGTS)
);