<?php
    
namespace HCM\FPA\ObrigacaoLegal\Dirf;

class QueryDirf
{
    public function __construct($entityManager, $hcmParameters){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function get_respo($params){
        $sql = $this->entityManager->getConnection()->prepare("
SELECT
  PE.NRPESSOA,
  'RESPO|'                                   NMIDENTIFICADOR,
  LPAD(REPLACE(REPLACE(PEH.NRCPFPESSOA,'.',''),'-',''), 11, '0')      || '|' NRCPF,
  SUBSTR(PEH.NMPESSOA, 1, 60)         || '|' NMNOMERESP,
  SUBSTR( TRIM( LEADING '0' FROM REPLACE( TRANSLATE( TEL.CDPREFIXCOMUPARC, '() ', '-'), '-', '') ), 1, 2 ) || '|' NRDDD,
  SUBSTR(                        REPLACE( TRANSLATE( TEL.CDCOMUNICAPARC,   '() ', '-'), '-', '')  , 1, 9 ) || '|' NRTELEFONE,
  '|'                                        NRRAMAL,
  SUBSTR( REPLACE( TRANSLATE( FAX.CDCOMUNICAPARC, '() ', '-'), '-', ''), 1, 9 )                            || '|' NRFAX,
  SUBSTR( EMA.CDCOMUNICAPARC, 1, 50 ) || '|' NMEMAIL
FROM GPE_PESSOA PE
LEFT JOIN GPE_PESSOAH PEH ON PEH.NRORG        = PE.NRORG
                         AND PEH.NRPESSOA     = PE.NRPESSOA
LEFT JOIN COMUNICAPARC TEL ON TEL.NRORG         = PE.NRORG
                          AND TEL.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                          AND TEL.CDFORMACOMU   = 1 
LEFT JOIN COMUNICAPARC FAX ON FAX.NRORG         = PE.NRORG
                          AND FAX.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                          AND FAX.CDFORMACOMU   = 10 
LEFT JOIN COMUNICAPARC EMA ON EMA.NRORG         = PE.NRORG
                          AND EMA.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                          AND EMA.CDFORMACOMU   = 5 
WHERE PE.NRORG    = :nrorg
  AND PE.NRPESSOA = :nrpessresponsa 
  AND ( PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                               WHERE DTMESCOMPETENC <= :dtcompetencia 
                                 AND NRORG    = PE.NRORG
                                 AND NRPESSOA = PE.NRPESSOA )
        OR PEH.DTMESCOMPETENC IS NULL )
  AND ( TEL.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                               WHERE NRORG         = PE.NRORG
                                 AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                 AND CDFORMACOMU   = 1 )
        OR TEL.NRCOMUNICAPARC IS NULL )
  AND ( FAX.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                               WHERE NRORG         = PE.NRORG
                                 AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                 AND CDFORMACOMU   = 10 )
        OR FAX.NRCOMUNICAPARC IS NULL )

  AND ( EMA.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                               WHERE NRORG         = PE.NRORG
                                 AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                 AND CDFORMACOMU   = 5 )
        OR EMA.NRCOMUNICAPARC IS NULL )
");
        $sql->execute($params);
    return $sql->fetchAll();
    }
    
    public function get_decpj($params){
        $sql = $this->entityManager->getConnection()->prepare("
SELECT
  'DECPJ|'                                     NMIDENTIFICADOR,
  LPAD( SUBSTR( EH.CDCNPJESTRUT, 1, 14), 14, '0' ) || '|' CDCNPJ,
  SUBSTR( EH.NMRAZSOCESTRUT, 1, 150 )   || '|' NOMEEMPRESARIAL,
  :idnaturezadecl               || '|' IDNATUREZADECLA,
  LPAD(REPLACE(REPLACE(PEH.NRCPFPESSOA,'.',''),'-',''), 11, '0')        || '|' CDCPFRESP,
  :idsocioostensi               || '|' IDSOCIOSTENS,
  :iddepositjudic               || '|' IDDEPOJUDIC,
  :idinstitinvest               || '|' IDINSTINVEST,
  :idpagrendiexte               || '|' IDPAGRENDEXT,
  :idpagplanosaud               || '|' IDPAGPLANSAUD,
  :idpagrelaccopa               || '|' IDPAGRELCOPA,
  :idpagrelacolimp              || '|' IDPAGRELOLIMP,
  :idpagsituaespe               || '|' IDPAGSITESPE,
  TO_CHAR( :dteventoespeci, 'YYYYMMDD') || '|' DTEVENTDECPJ,
  NVL(EM.NRREGIMEAPUR,1) AS NRREGIMEAPUR  /*Tipo de Regime de Apuração: 1-Competência 2-Caixa*/
FROM ESTRUTURAH EH
LEFT JOIN ESTRUTURAM EM ON EH.NRORG = EM.NRORG
                  AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
LEFT JOIN GPE_PESSOA   PE ON PE.NRORG         = EH.NRORG
                         AND PE.NRPARCNEGOCIO = EH.NRPARCENTISIN  
LEFT JOIN GPE_PESSOAH PEH ON PEH.NRORG        = EH.NRORG
                         AND PEH.NRPESSOA     = PE.NRPESSOA
                         AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                     WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                       AND NRORG    = PE.NRORG
                                                       AND NRPESSOA = PE.NRPESSOA )

WHERE EH.NRORG        = :nrorg 
  AND EH.NRESTRUTURAM = :nrestrresponsa 
  AND EH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                            WHERE DTMESCOMPETENC <= :dtcompetencia
                              AND NRORG        = EH.NRORG
                              AND NRESTRUTURAM = EH.NRESTRUTURAM )
"); 
        $sql->execute($params);
        return $sql->fetchAll();
    }

    public function get_motor($params,$queryPart,$idDecTerceiro,$queryPartCdReceita,$idInforme,$idFerias,$idEstagiario,$regimeQryPart){
        $sql = $this->entityManager->getConnection()->prepare("
        SELECT
  SUM(DECODE(PRIN.NMITEM, 'RTRT',
      ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) + NVL(M13, 0), 2 ), 0)
  ) OVER(PARTITION BY PRIN.NRCPFPESSOA, PRIN.CDRECEITA) TOTAL_RTRT,
  SUM(
    DECODE(PRIN.NMITEM, 'RTIRF',
      ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) + NVL(M13, 0), 2 ), 0)
  ) OVER(PARTITION BY PRIN.NRCPFPESSOA, PRIN.CDRECEITA) TOTAL_RTIRF,
  PRIN.NRTIPOVINCULOM,
  /*PRIN.NRESTRUTLEGAL,*/
  /*PRIN.NRVINCULOM,*/
  PRIN.NRCPFPESSOA,
  /*PRIN.NMVINCULOM,*/
  PRIN.NMPESSOA,
  /*PRIN.DTADMISSAOVINC,*/
  PRIN.NMITEM,
  CASE  /*Verifica se o registro pode ser relacionado no TXT da DIRF*/
    WHEN INSTR(PRIN.NMITEM, :idinforme /*'-INF'*/) > 0 THEN 'N' /*Não aparece no TXT da DIRF*/
    ELSE 'S'
  END FLAG_TXT,
  ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) /*+ NVL(M13, 0)*/, 2 ) TOTAL,
  ROUND( NVL(PRIN.M13, 0), 2 ) TOTAL13,
  PRIN.IDREC, /*3.5*/
  PRIN.CDRECEITA,
  PRIN.BPFDEC, /*3.6*/
  PRIN.CDCPF,
  PRIN.NOME,
  PRIN.DTMOLESTIA,
  /*5 Indicador de identificação do alimentando; C Fixo 1; S – Existem informações detalhadas do alimentando. N – Não existem informações detalhadas do alimentando.*/
                   /*5 Indicador de identificação do alimentando*/
  'N|' IDPREVCOMP, /*6 Indicador de identificação da previdência complementar; C Fixo 1;*/
  PRIN.CDREGISTRO, /*4.6*/
  SUBSTR( ( ROUND(PRIN.M01, 2) * 100 ), 1, 13 ) || '|' M01,
  SUBSTR( ( ROUND(PRIN.M02, 2) * 100 ), 1, 13 ) || '|' M02,
  SUBSTR( ( ROUND(PRIN.M03, 2) * 100 ), 1, 13 ) || '|' M03,
  SUBSTR( ( ROUND(PRIN.M04, 2) * 100 ), 1, 13 ) || '|' M04,
  SUBSTR( ( ROUND(PRIN.M05, 2) * 100 ), 1, 13 ) || '|' M05,
  SUBSTR( ( ROUND(PRIN.M06, 2) * 100 ), 1, 13 ) || '|' M06,
  SUBSTR( ( ROUND(PRIN.M07, 2) * 100 ), 1, 13 ) || '|' M07,
  SUBSTR( ( ROUND(PRIN.M08, 2) * 100 ), 1, 13 ) || '|' M08,
  SUBSTR( ( ROUND(PRIN.M09, 2) * 100 ), 1, 13 ) || '|' M09,
  SUBSTR( ( ROUND(PRIN.M10, 2) * 100 ), 1, 13 ) || '|' M10,
  SUBSTR( ( ROUND(PRIN.M11, 2) * 100 ), 1, 13 ) || '|' M11,
  SUBSTR( ( ROUND(PRIN.M12, 2) * 100 ), 1, 13 ) || '|' M12,
  SUBSTR( ( ROUND(PRIN.M13, 2) * 100 ), 1, 13 ) || '|' M13,
  SUBSTR( ( ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) /*+ NVL(M13, 0)*/, 2 ) * 100 ), 1, 13 ) || '|' ANO,
  COMP.COMPLEMENTO
FROM (
  SELECT * FROM ( /*este select é para o pivo funcionar*/
  SELECT
    NRTIPOVINCULOM,
    /*NRESTRUTLEGAL,*/
    NRCPFPESSOA,
    NMPESSOA,
    NMITEM,
    IDREC,
    CDRECEITA,
    BPFDEC,
    CDCPF,
    NOME,
    DTMOLESTIA,
    CDREGISTRO,
    SUBSTR(MES,5,2) MES,
    VREVENTOFOLHA
  FROM (
    SELECT 
      /*VM.NRVINCULOM,*/
      /*VM.NMVINCULOM,*/
      VM.NRTIPOVINCULOM,
      /*VH.NRESTRUTLEGAL,*/
      PH.NRCPFPESSOA,
      PH.NMPESSOA,
      /*VM.DTADMISSAOVINC,*/
      REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, :iddecterceiro /*'-13S'*/, ''), :idferias /*'-FERIAS'*/, ''), :idestagiario /*'-ESTAG'*/, ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') NMITEM, /*Remove a idêntificação do 13º salário (este vai para o M13 e VALOR13)*/
      /*GIT.NRITEM,*/
      'IDREC|'                             IDREC, /*3.5*/
      CASE
        ".$queryPartCdReceita."/*WHEN VM.NRTIPOVINCULOM = 2 THEN '0588|'*/
        ELSE LPAD(VE.CODRECEITA, 4, '0')   || '|'
      END CDRECEITA,
      'BPFDEC|'                            BPFDEC, /*3.6*/
      LPAD(REPLACE(REPLACE(PH.NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
      SUBSTR(PH.NMPESSOA, 1, 60)    || '|' NOME,
      '|'                                  DTMOLESTIA,
      REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, :iddecterceiro /*'-13S'*/, ''), :idferias /*'-FERIAS'*/, ''), :idestagiario /*'-ESTAG'*/, ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') || '|' CDREGISTRO, /*4.6*/
      CASE
        ".$regimeQryPart[0]."
        WHEN INSTR(GIT.NMITEM, :iddecterceiro /*'-13S'*/) > 0 THEN TO_CHAR(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'yyyy')||'13' /*Verifica se o item é do 13º salário (Ex.: se o id13Sal for '-13S' então 'RTRT-13S' é o M13 do 'RTRT')*/
/*RegimeCaixa*/
        ".$regimeQryPart[1]."
        WHEN GIT.NMITEM = 'RTPO' AND ICF.NREVENTOM IN (1140,1145) AND TO_CHAR(ICF.DTOCORRENCIA, 'yyyy') = TO_CHAR(CF.DTOCORRENCIA, 'yyyy') THEN TO_CHAR(ICF.DTOCORRENCIA, 'yyyymm')
        WHEN GIT.NMITEM = 'RTPO' AND ICF.NREVENTOM IN (1140,1145) AND TO_CHAR(ICF.DTOCORRENCIA, 'yyyy') <> TO_CHAR(CF.DTOCORRENCIA, 'yyyy') THEN TO_CHAR(ICF.DTOCORRENCIA, 'yyyymm') /*férias partidas que terminam no ano seguinte*/
        WHEN GIT.NMITEM = 'RTPO-FERIAS' AND ICF.NREVENTOM IN (1140) THEN TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
        WHEN GIT.NMITEM = 'RTPO-FERIAS' AND ICF.NREVENTOM IN (1145) THEN TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
        ".$regimeQryPart[2]."
        ELSE TO_CHAR(CF.DTOCORRENCIA, 'yyyymm')
      END MES, /*são as colunas do pivô*/
      CASE
        WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º na rescisao caso não possua data de rescisão*/
        AND VM.DTRESCISAOVINC IS NULL AND IEV.NREVENTOM IN (600,1180)
        THEN 0
        WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º caso possua data de rescisão*/
        AND VM.DTRESCISAOVINC IS NOT NULL AND VM.DTRESCISAOVINC <= LAST_DAY(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/)) AND IEV.NREVENTOM IN (110,125,1150)
        THEN 0
        
        WHEN GIT.NMITEM = 'RTPO' /*Zera o RTPO caso o RTRT for zero, pois não há IR, então não há deduções para cálculo de IR*/
        AND (SELECT  SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
               FROM FPA_ITECALCFOLHA IC
               JOIN FPA_INCIDEVENTO IE ON (IE.NRORG = 0 OR IE.NRORG = IC.NRORG)
                                      AND IE.NREVENTOM = IC.NREVENTOM
                                      AND IE.NRTIPOINCIDE = 73 /*RTRT*/
              WHERE IC.NRORG = CF.NRORG
                AND IC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                AND IC.NRVINCULOM = VM.NRVINCULOM) = 0
        THEN 0
        WHEN GIT.NMITEM IN ('RTRT-ESTAG') /*Zera itens de estagiário quando o tipo de vínculo não for estagiário*/
        AND VM.NRTIPOVINCULOM <> 2 /*Estagiário*/
        THEN 0
        ".$regimeQryPart[3]."
        ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * ICF.VREVENTOFOLHA, ICF.VREVENTOFOLHA)) /*Considera o '+' e '-' no sum*/
      END VREVENTOFOLHA
    FROM GPE_VINCULOM VM
    /*Código da receita do vínculo em questão (item 3.5)*/
    LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
    /*CPF e Nome do vínculo em questão (item 3.6)*/
    JOIN GPE_PESSOA  PE ON PE.NRORG    = VM.NRORG
                       AND PE.NRPESSOA = VM.NRPESSOA
    JOIN GPE_PESSOAH PH ON PH.NRORG    = VM.NRORG
                       AND PH.NRPESSOA = PE.NRPESSOA
                       AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                 WHERE DTMESCOMPETENC <= :dtcompetencia
                                                   AND NRORG    = VM.NRORG
                                                   AND NRPESSOA = PE.NRPESSOA )
    /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
    JOIN (SELECT GIT.NRORG, GIT.NRITEM, GIT.NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE
            FROM FPA_GRPITEM GIT
           WHERE (GIT.NRORG = :nrorg /*:P_NRORG*/ OR GIT.NRORG = 0)
                             AND GIT.NRGRPINCIDE  = :nrgrupoinciden /*:P_NRGRPDIRF*/
/*RegimeCaixa*/
          ".$regimeQryPart[4]." ) GIT ON ( GIT.NRORG = VM.NRORG OR GIT.NRORG = 0 )
             AND GIT.NRGRPINCIDE  = :nrgrupoinciden /*:P_NRGRPDIRF*/
    JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = VM.NRORG OR IEV.NRORG = 0 )
                             AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
    JOIN FPA_CALCULOFOLHA  CF ON CF.NRORG          = VM.NRORG
                             AND ( /*CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 1)
                                   OR */CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 2)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP-DIFF', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 19)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idFerias."', 2)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idEstagiario."', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 2)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idFerias."', 2)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
                                   /*OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)*/
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP".$idDecTerceiro."', 4)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 8)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 4)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 8)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 4)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 8)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 4)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA".$idDecTerceiro."', 8)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA".$idDecTerceiro."', 4)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 8)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 4)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 10)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 2)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIDAC', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
                                   OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIO', 1)
/*RegimeCaixa*/
                                   ".$regimeQryPart[5]." )
                             AND CF.NRTPMODALIDCAL = :nrcenario /*:P_CENARIO*/ /*Cenário real apenas*/
                             ".$regimeQryPart[6]."
    JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
    JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                        AND VH.NRVINCULOM = VM.NRVINCULOM
                        AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                  WHERE DTMESCOMPETENC <= DT.DTDATA /*CF.DTOCORRENCIA*/
                                                    AND NRORG      = VM.NRORG
                                                    AND NRVINCULOM = VM.NRVINCULOM )
    JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = VM.NRORG
                             AND ICF.NRVINCULOM     = VM.NRVINCULOM
                             AND ICF.NREVENTOM      = IEV.NREVENTOM
                             AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
               AND ICF.NREVENTOM = DECODE(CF.NRTIPOMOVIMENT, 10, DECODE(ICF.NREVENTOM, 475, 475, DECODE(DT.DTDATA /*CF.DTOCORRENCIA*/, TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 1390, 0)), ICF.NREVENTOM)
               AND ICF.NREVENTOM = DECODE(CF.NRTIPOMOVIMENT,  1, DECODE(ICF.NREVENTOM, 205239, 0, 205543, 0, ICF.NREVENTOM), ICF.NREVENTOM) /*Apenas devem vir no movimento 4 (13º sal)*/
    WHERE VM.NRORG = :nrorg
      AND ( VM.DTRESCISAOVINC IS NULL
            OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) ) )
      AND GIT.NRITEM != 99 /*Todos os itens, exceto o 'informações complementares'*/
      ".$queryPart."
      AND EXISTS ( SELECT 1
                     FROM FPA_ITECALCFOLHA
                    WHERE NRORG = CF.NRORG
                      AND NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                      AND NRVINCULOM = VM.NRVINCULOM
                      AND NREVENTOM IN (SELECT NREVENTOM FROM FPA_INCIDEVENTO WHERE (NRORG = CF.NRORG OR NRORG = 0) AND NRTIPOINCIDE = 109)
                      AND VREVENTOFOLHA > 0 )
)
  WHERE SUBSTR(MES,1,4) = TO_CHAR(TO_DATE(:dtcompetencia), 'yyyy')
  ) PIVOT ( SUM(VREVENTOFOLHA)
            FOR MES IN ('01' AS M01, '02' AS M02, '03' AS M03, '04' AS M04, '05' AS M05, '06' AS M06, '07' AS M07, '08' AS M08, '09' AS M09, '10' AS M10, '11' AS M11, '12' AS M12, '13' AS M13) )
  WHERE CDRECEITA IS NOT NULL /*eventos excluídos não devem ser considerados*/
) PRIN
LEFT JOIN (SELECT
              RES.NRCPFPESSOA,
              LISTAGG(RES.COMPLEMENTO, CHR(13)) WITHIN GROUP (ORDER BY RES.NRCPFPESSOA) COMPLEMENTO
            FROM (SELECT
                      RES.NRCPFPESSOA,
                      DECODE( RES.NREVENTOM, NULL,
                        /*Outras despesas*/
                        'OUTRAS DESPESAS MEDICOODONTOHOSPITALARES: R$' || TO_CHAR(RES.VREVENTOFOLHA, '9g990d00'),
                        /*Operadoras diversas*/
                        CHR(13) || 'Operadora: ' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 1, 3) || '.' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 4, 3) || '.' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 7, 3) || '/' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 10, 4) || '-' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 14, 2) ||
                        ' - ' || RES.NMRAZSOCESTRUT || CHR(13) || 'Valor pago no ano referente ao titular: R$' ||
                        TO_CHAR(RES.VREVENTOFOLHA, '9g990d00') )
                      COMPLEMENTO
                    FROM (SELECT 
                            PH.NRCPFPESSOA, ESH.CDCNPJESTRUT, ESH.NMRAZSOCESTRUT, VEV.NREVENTOM, SUM(ICF.VREVENTOFOLHA) VREVENTOFOLHA
                          FROM GPE_VINCULOM VM
                          JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                              AND VH.NRVINCULOM = VM.NRVINCULOM
                          /*CPF e Nome do vínculo em questão (item 3.6)*/
                          JOIN GPE_PESSOAH PH ON PH.NRORG    = VM.NRORG
                                             AND PH.NRPESSOA = VM.NRPESSOA
                                             AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                        WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                          AND NRORG    = VM.NRORG
                                                                          AND NRPESSOA = VM.NRPESSOA )
                          /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                          JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = VM.NRORG OR GIN.NRORG = 0 )
                                                   AND GIN.NRGRPINCIDE = :nrgrupoinciden 
                          JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = VM.NRORG OR GIT.NRORG = 0 )
                                                   AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                                                   AND GIT.NRITEM = 99 /*Apenas 'informações complementares'*/
                          JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = VM.NRORG OR IEV.NRORG = 0 )
                                                   AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                          JOIN FPA_CALCULOFOLHA  CF ON CF.NRORG          = VM.NRORG
                                                   AND CF.NRTIPOMOVIMENT = 1 
                                                   AND CF.NRTPMODALIDCAL = :nrcenario  
                                                   AND CF.DTOCORRENCIA BETWEEN TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) AND :dtcompetencia 
                          JOIN DATA DT2 ON DT2.DTDATA = CF.DTOCORRENCIA
                          JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = VM.NRORG
                                                   AND ICF.NRVINCULOM     = VM.NRVINCULOM
                                                   AND ICF.NREVENTOM      = IEV.NREVENTOM
                                                   AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                                   AND ICF.VREVENTOFOLHA > 0
                          LEFT JOIN FPA_VINCEVENTO VEV ON VEV.NRORG = VM.NRORG
                                                 AND VEV.NRVINCULOM = VM.NRVINCULOM
                                                 AND VEV.NREVENTOM = ICF.NREVENTOM
                                                 AND ICF.DTOCORRENCIA BETWEEN VEV.DTINIVIGENCIA AND NVL(VEV.DTFIMVIGENCIA, LAST_DAY(:dtcompetencia ))
                          LEFT JOIN ESTRUTURAM ESM ON ESM.NRORG        = VM.NRORG
                                                  AND ESM.NRESTRUTURAM = VEV.NRESTRUTURAM
                          LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG        = VM.NRORG
                                                  AND ESH.NRESTRUTURAM = ESM.NRESTRUTURAM
                                                  AND ESH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                             WHERE DTMESCOMPETENC <= TO_DATE( :dtcompetencia  ) 
                                                                               AND NRORG        = VM.NRORG
                                                                               AND NRESTRUTURAM = ESM.NRESTRUTURAM )
                          WHERE VM.NRORG = :nrorg 
                            AND ( VM.DTRESCISAOVINC IS NULL OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
                            AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                      WHERE DTMESCOMPETENC <=  DT2.DTDATA /*CF.DTOCORRENCIA*/
                                                        /*AND DTMESCOMPETENC >= TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' )*/
                                                        AND NRORG      = VM.NRORG
                                                        AND NRVINCULOM = VM.NRVINCULOM )
                            ".$queryPart."
                          GROUP BY PH.NRCPFPESSOA, ESH.CDCNPJESTRUT, ESH.NMRAZSOCESTRUT, VEV.NREVENTOM
                        ) RES
                      UNION ALL
                        SELECT DISTINCT 
                          PH.NRCPFPESSOA,
                          'PENSIONISTA: ' || PHD.NRCPFPESSOA || '-' || PHD.NMPESSOA COMPLEMENTO
                        FROM GPE_VINCULOM VM
                        JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                            AND VH.NRVINCULOM = VM.NRVINCULOM
                        /*CPF e Nome do vínculo em questão (item 3.6)*/
                        JOIN GPE_PESSOAH PH ON PH.NRORG    = VM.NRORG
                                           AND PH.NRPESSOA = VM.NRPESSOA
                                           AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                      WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                        AND NRORG    = VM.NRORG
                                                                        AND NRPESSOA = VM.NRPESSOA )
                        /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                        JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = VM.NRORG OR GIN.NRORG = 0 )
                                                 AND GIN.NRGRPINCIDE = :nrgrupoinciden 
                        JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = VM.NRORG OR GIT.NRORG = 0 )
                                                 AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                                                 AND GIT.NMITEM = 'RTPA' /*Apenas 'pensão alimentícia'*/
                        JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = VM.NRORG OR IEV.NRORG = 0 )
                                                 AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                        JOIN FPA_CALCULOFOLHA  CF ON CF.NRORG          = VM.NRORG
                                                 AND CF.NRTIPOMOVIMENT = 1 
                                                 AND CF.NRTPMODALIDCAL = :nrcenario  
                                                 AND CF.DTOCORRENCIA BETWEEN TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) AND :dtcompetencia 
                        JOIN DATA DT3 ON DT3.DTDATA = CF.DTOCORRENCIA
                        JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = VM.NRORG
                                                 AND ICF.NRVINCULOM     = VM.NRVINCULOM
                                                 AND ICF.NREVENTOM      = IEV.NREVENTOM
                                                 AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                        LEFT JOIN FPA_DEPVINCULO DEP ON DEP.NRORG = VM.NRORG
                                                    AND DEP.NRVINCULOM = VM.NRVINCULOM
                                                    AND DEP.NRTIPODEPENDE = 3
                        LEFT JOIN GPE_PESSOAH PHD ON PHD.NRORG    = VM.NRORG
                                                 AND PHD.NRPESSOA = DEP.NRPESSOA
                                                 AND PHD.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                             WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                               AND NRORG    = PHD.NRORG
                                                                               AND NRPESSOA = PHD.NRPESSOA )
                        WHERE VM.NRORG = :nrorg
                          AND ( VM.DTRESCISAOVINC IS NULL OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
                          AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                    WHERE DTMESCOMPETENC <= DT3.DTDATA /*CF.DTOCORRENCIA*/
                                                      /*AND DTMESCOMPETENC >= TRUNC( TO_DATE( :dtcompetencia), 'YEAR' )*/
                                                      AND NRORG      = VM.NRORG
                                                      AND NRVINCULOM = VM.NRVINCULOM )
                          ".$queryPart."
            ) RES
            GROUP BY RES.NRCPFPESSOA
) COMP ON COMP.NRCPFPESSOA = PRIN.NRCPFPESSOA
WHERE PRIN.CDRECEITA IS NOT NULL /*eventos excluídos não devem ser considerados*/
ORDER BY CDRECEITA, CDCPF, DECODE(NMITEM, 'RTPA', 'AAAA', NMITEM)");
        $params['idferias'] =  $idFerias;
        $params['idestagiario'] =  $idEstagiario;
        $params['iddecterceiro'] =  $idDecTerceiro;
        $params['idinforme'] =  $idInforme;
        
        $sql->execute($params);
        
        return $sql->fetchAll();
    }

    public function get_motor_new_insert($params,$queryPartOld){
        $sql = <<<SQL
INSERT INTO LANCAMENTOSVINC_TMP
	SELECT 
		  VM.NRORG, VM.NRVINCULOM, VM.NRPESSOA, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, VM.NRTIPOVINCULOM, VM.NRVINCULOEMPREG, VM.NMVINCULOM,
		  VH.DTMESCOMPETENC, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN, VH.NRESTRUTSIND,
		  CF.NRCALCULOFOLHA, CF.NRTIPOMOVIMENT, CF.NRTPMODALIDCAL, CF.NROCORRECAL, CF.DTOCORRENCIA AS DTOCORRENCIACALC,
		  ICF.NRITEMCALCFOLHA, ICF.NREVENTOM, ICF.VRREFFOLHA, ICF.VREVENTOFOLHA, ICF.IDREFEVALORCALC, ICF.DTOCORRENCIA,
      CASE WHEN CF.DTOCORRENCIA = TRUNC(VM.DTRESCISAOVINC,'MONTH')
           THEN (SELECT RESC.DTOCORRENCIA
                   FROM FPA_CALCULOFOLHA CFR
                   JOIN FPA_ITECALCFOLHA RESC ON RESC.NRORG = CFR.NRORG
                                             AND RESC.NRCALCULOFOLHA = CFR.NRCALCULOFOLHA
                                             AND RESC.NRVINCULOM = VM.NRVINCULOM
                                             AND RESC.NREVENTOM = 3050
                  WHERE CFR.NRORG = VM.NRORG
                    AND CFR.NRTIPOMOVIMENT = 1
                    AND CFR.DTOCORRENCIA = TRUNC(VM.DTRESCISAOVINC,'MONTH')
                    AND CFR.NRTPMODALIDCAL = CF.NRTPMODALIDCAL
                    AND CFR.NROCORRECAL = 1)
           ELSE NULL
      END AS DTOCORRENCIARESC
	 FROM FPA_CALCULOFOLHA CF 
	 JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
	 JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG = CF.NRORG
							  AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
	 JOIN GPE_VINCULOM VM ON VM.NRORG = ICF.NRORG
							  AND VM.NRVINCULOM = ICF.NRVINCULOM
	 JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
						 AND VH.NRVINCULOM = VM.NRVINCULOM
						 AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM (SELECT H1.DTMESCOMPETENC FROM GPE_VINCULOH H1
                                												    WHERE H1.NRORG      = VH.NRORG
                                													  AND H1.NRVINCULOM = VH.NRVINCULOM
                                													  AND H1.DTMESCOMPETENC <= DT.DTDATA ORDER BY H1.DTMESCOMPETENC DESC) WHERE ROWNUM = 1)
	 WHERE CF.NRORG = :nrorg
	   AND CF.DTOCORRENCIA BETWEEN ADD_MONTHS(TRUNC(TO_DATE(:dtcompetencia),'YEAR'),-1) AND TO_DATE(:dtcompetencia)
	   AND CF.NRTPMODALIDCAL = :nrcenario /*Cenário real apenas*/
	   $queryPartOld
SQL;
        $this->entityManager->getConnection()->executeUpdate($sql, $params);
    }

    public function get_motor_new($params,$queryPartOld,$queryPart,$idDecTerceiro,$queryPartCdReceita,$idInforme,$idFerias,$idEstagiario,$regimeQryPart,$count=''){
        $sql = $this->entityManager->getConnection()->prepare("
        /* get_motor_new $count*/
        SELECT
  SUM(DECODE(PRIN.NMITEM, 'RTRT',
      ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) + NVL(M13, 0), 2 ), 0)
  ) OVER(PARTITION BY PRIN.NRCPFPESSOA, PRIN.CDRECEITA) TOTAL_RTRT,
  SUM(
    DECODE(PRIN.NMITEM, 'RTIRF',
      ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) + NVL(M13, 0), 2 ), 0)
  ) OVER(PARTITION BY PRIN.NRCPFPESSOA, PRIN.CDRECEITA) TOTAL_RTIRF,
  PRIN.NRTIPOVINCULOM,
  /*PRIN.NRESTRUTLEGAL,*/
  /*PRIN.NRVINCULOM,*/
  PRIN.NRCPFPESSOA,
  /*PRIN.NMVINCULOM,*/
  PRIN.NMPESSOA,
  /*PRIN.DTADMISSAOVINC,*/
  PRIN.NMITEM,
  CASE  /*Verifica se o registro pode ser relacionado no TXT da DIRF*/
    WHEN INSTR(PRIN.NMITEM, :idinforme /*'-INF'*/) > 0 THEN 'N' /*Não aparece no TXT da DIRF*/
    ELSE 'S'
  END FLAG_TXT,
  ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) /*+ NVL(M13, 0)*/, 2 ) TOTAL,
  ROUND( NVL(PRIN.M13, 0), 2 ) TOTAL13,
  PRIN.IDREC, /*3.5*/
  PRIN.CDRECEITA,
  PRIN.BPFDEC, /*3.6*/
  PRIN.CDCPF,
  PRIN.NOME,
  PRIN.DTMOLESTIA,
  /*5 Indicador de identificação do alimentando; C Fixo 1; S – Existem informações detalhadas do alimentando. N – Não existem informações detalhadas do alimentando.*/
                   /*5 Indicador de identificação do alimentando*/
  'N|' IDPREVCOMP, /*6 Indicador de identificação da previdência complementar; C Fixo 1;*/
  PRIN.CDREGISTRO, /*4.6*/
  SUBSTR( ( ROUND(CASE WHEN PRIN.M01 < 0 THEN 0 ELSE PRIN.M01 END, 2) * 100 ), 1, 13 ) || '|' M01,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M02 < 0 THEN 0 ELSE PRIN.M02 END, 2) * 100 ), 1, 13 ) || '|' M02,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M03 < 0 THEN 0 ELSE PRIN.M03 END, 2) * 100 ), 1, 13 ) || '|' M03,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M04 < 0 THEN 0 ELSE PRIN.M04 END, 2) * 100 ), 1, 13 ) || '|' M04,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M05 < 0 THEN 0 ELSE PRIN.M05 END, 2) * 100 ), 1, 13 ) || '|' M05,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M06 < 0 THEN 0 ELSE PRIN.M06 END, 2) * 100 ), 1, 13 ) || '|' M06,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M07 < 0 THEN 0 ELSE PRIN.M07 END, 2) * 100 ), 1, 13 ) || '|' M07,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M08 < 0 THEN 0 ELSE PRIN.M08 END, 2) * 100 ), 1, 13 ) || '|' M08,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M09 < 0 THEN 0 ELSE PRIN.M09 END, 2) * 100 ), 1, 13 ) || '|' M09,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M10 < 0 THEN 0 ELSE PRIN.M10 END, 2) * 100 ), 1, 13 ) || '|' M10,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M11 < 0 THEN 0 ELSE PRIN.M11 END, 2) * 100 ), 1, 13 ) || '|' M11,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M12 < 0 THEN 0 ELSE PRIN.M12 END, 2) * 100 ), 1, 13 ) || '|' M12,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M13 < 0 THEN 0 ELSE PRIN.M13 END, 2) * 100 ), 1, 13 ) || '|' M13,
  SUBSTR( ( ROUND( CASE WHEN NVL(PRIN.M01, 0) < 0 THEN 0 ELSE NVL(PRIN.M01, 0) END + 
                   CASE WHEN NVL(PRIN.M02, 0) < 0 THEN 0 ELSE NVL(PRIN.M02, 0) END + 
                   CASE WHEN NVL(PRIN.M03, 0) < 0 THEN 0 ELSE NVL(PRIN.M03, 0) END + 
                   CASE WHEN NVL(PRIN.M04, 0) < 0 THEN 0 ELSE NVL(PRIN.M04, 0) END + 
                   CASE WHEN NVL(PRIN.M05, 0) < 0 THEN 0 ELSE NVL(PRIN.M05, 0) END + 
                   CASE WHEN NVL(PRIN.M06, 0) < 0 THEN 0 ELSE NVL(PRIN.M06, 0) END + 
                   CASE WHEN NVL(PRIN.M07, 0) < 0 THEN 0 ELSE NVL(PRIN.M07, 0) END + 
                   CASE WHEN NVL(PRIN.M08, 0) < 0 THEN 0 ELSE NVL(PRIN.M08, 0) END + 
                   CASE WHEN NVL(PRIN.M09, 0) < 0 THEN 0 ELSE NVL(PRIN.M09, 0) END + 
                   CASE WHEN NVL(PRIN.M10, 0) < 0 THEN 0 ELSE NVL(PRIN.M10, 0) END + 
                   CASE WHEN NVL(PRIN.M11, 0) < 0 THEN 0 ELSE NVL(PRIN.M11, 0) END + 
                   CASE WHEN NVL(PRIN.M12, 0) < 0 THEN 0 ELSE NVL(PRIN.M12, 0) END /*+ NVL(M13, 0)*/, 2 ) * 100 ), 1, 13 ) || '|' ANO,
  COMP.COMPLEMENTO
FROM (
  SELECT * FROM ( /*este select é para o pivo funcionar*/
      SELECT
        NRTIPOVINCULOM,
        /*NRESTRUTLEGAL,*/
        NRCPFPESSOA,
        NMPESSOA,
        NMITEM,
        IDREC,
        CDRECEITA,
        BPFDEC,
        CDCPF,
        NOME,
        DTMOLESTIA,
        CDREGISTRO,
        SUBSTR(MES,5,2) MES,
        VREVENTOFOLHA
      FROM (
        SELECT
          /*LANC.NRVINCULOM,*/
          /*LANC.NMVINCULOM,*/
          LANC.NRTIPOVINCULOM,
          /*LANC.NRESTRUTLEGAL,*/
          PH.NRCPFPESSOA,
          PH.NMPESSOA,
          /*LANC.DTADMISSAOVINC,*/
          REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, :iddecterceiro /*'-13S'*/, ''), :idferias /*'-FERIAS'*/, ''), :idestagiario /*'-ESTAG'*/, ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') NMITEM, /*Remove a idêntificação do 13º salário (este vai para o M13 e VALOR13)*/
          /*GIT.NRITEM,*/
          'IDREC|'                             IDREC, /*3.5*/
          CASE
            ".$queryPartCdReceita."/*WHEN LANC.NRTIPOVINCULOM = 2 THEN '0588|'*/
            ELSE LPAD(VE.CODRECEITA, 4, '0')   || '|'
          END CDRECEITA,
          'BPFDEC|'                            BPFDEC, /*3.6*/
          LPAD(REPLACE(REPLACE(PH.NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
          SUBSTR(PH.NMPESSOA, 1, 60)    || '|' NOME,
          '|'                                  DTMOLESTIA,
          REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, :iddecterceiro /*'-13S'*/, ''), :idferias /*'-FERIAS'*/, ''), :idestagiario /*'-ESTAG'*/, ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') || '|' CDREGISTRO, /*4.6*/
          CASE
            ".$regimeQryPart[0]."
            WHEN INSTR(GIT.NMITEM, :iddecterceiro /*'-13S'*/) > 0 THEN TO_CHAR(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'yyyy')||'13' /*Verifica se o item é do 13º salário (Ex.: se o id13Sal for '-13S' então 'RTRT-13S' é o M13 do 'RTRT')*/
            ".$regimeQryPart[1]."
            --WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) AND TO_CHAR(LANC.DTOCORRENCIA, 'yyyy') = TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyy') THEN TO_CHAR(LANC.DTOCORRENCIA, 'yyyymm')
            --WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) AND TO_CHAR(LANC.DTOCORRENCIA, 'yyyy') <> TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyy') THEN TO_CHAR(LANC.DTOCORRENCIA, 'yyyymm') /*férias partidas que terminam no ano seguinte*/
            WHEN GIT.NMITEM = 'RTPO-FERIAS' AND LANC.NREVENTOM IN (1140) THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyymm')
            WHEN GIT.NMITEM = 'RTPO-FERIAS' AND LANC.NREVENTOM IN (1145) THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyymm')
            ".$regimeQryPart[8]."
            ".$regimeQryPart[2]."
            ELSE TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyymm')
          END MES, /*são as colunas do pivô*/
          CASE
            WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º na rescisao caso não possua data de rescisão*/
            AND LANC.DTRESCISAOVINC IS NULL AND IEV.NREVENTOM IN (600,1180)
            THEN 0
            WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º caso possua data de rescisão*/
            AND LANC.DTRESCISAOVINC IS NOT NULL AND LANC.DTRESCISAOVINC <= (TO_DATE(:dtcompetencia)+19) AND IEV.NREVENTOM IN (110,125,1150) /*Rescisoes ate o dia 20 nao tem 13o*/
            THEN 0
            /*WHEN GIT.NMITEM = 'RTPO' /*Zera o RTPO caso o RTRT for zero, pois não há IR, então não há deduções para cálculo de IR*
            AND (SELECT  SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
                   FROM FPA_ITECALCFOLHA IC
                   JOIN FPA_INCIDEVENTO IE ON (IE.NRORG = 0 OR IE.NRORG = IC.NRORG)
                                          AND IE.NREVENTOM = IC.NREVENTOM
                                          AND IE.NRTIPOINCIDE = 73 /*RTRT*
                  WHERE IC.NRORG = LANC.NRORG
                    AND IC.NRCALCULOFOLHA = LANC.NRCALCULOFOLHA
                    AND IC.NRVINCULOM = LANC.NRVINCULOM) = 0
            THEN 0*/
            WHEN GIT.NMITEM IN ('RTRT-ESTAG') /*Zera itens de estagiário quando o tipo de vínculo não for estagiário*/
            AND LANC.NRTIPOVINCULOM <> 2 /*Estagiário*/
            THEN 0
            ".$regimeQryPart[3]."
            ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * LANC.VREVENTOFOLHA, LANC.VREVENTOFOLHA)) /*Considera o '+' e '-' no sum*/
          END VREVENTOFOLHA
        FROM LANCAMENTOSVINC_TMP LANC
        /*Código da receita do vínculo em questão (item 3.5)*/
        LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = LANC.NRVINCULOEMPREG
        /*CPF e Nome do vínculo em questão (item 3.6)*/
        JOIN GPE_PESSOA  PE ON PE.NRORG    = LANC.NRORG
                           AND PE.NRPESSOA = LANC.NRPESSOA
        JOIN GPE_PESSOAH PH ON PH.NRORG    = LANC.NRORG
                           AND PH.NRPESSOA = PE.NRPESSOA
                           AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                     WHERE DTMESCOMPETENC <= :dtcompetencia
                                                       AND NRORG    = LANC.NRORG
                                                       AND NRPESSOA = PE.NRPESSOA )
        /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
        JOIN (SELECT GIT.NRORG, GIT.NRITEM, GIT.NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE
                FROM FPA_GRPITEM GIT
               WHERE (GIT.NRORG = :nrorg /*:P_NRORG*/ OR GIT.NRORG = 0)
                                 AND GIT.NRGRPINCIDE  = :nrgrupoinciden /*:P_NRGRPDIRF*/
    /*RegimeCaixa*/
              ".$regimeQryPart[4]." ) GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                                         AND GIT.NRGRPINCIDE  = :nrgrupoinciden /*:P_NRGRPDIRF*/
        JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                                 AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                                 AND IEV.NREVENTOM      = LANC.NREVENTOM
        WHERE LANC.NRORG = :nrorg
          AND ( LANC.DTRESCISAOVINC IS NULL
                OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) ) )
          AND ( /*LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 1)
               OR */LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP-DIFF', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 19)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idFerias."', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idEstagiario."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idFerias."', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 10)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIDAC', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIO', 1)
    /*RegimeCaixa*/
               ".$regimeQryPart[5]." )
         ".$regimeQryPart[6]."
          AND LANC.NREVENTOM = DECODE(LANC.NRTIPOMOVIMENT, 10, DECODE(LANC.NREVENTOM, 475, 475, DECODE(LANC.DTOCORRENCIACALC, TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 1390, 0)), LANC.NREVENTOM)
          AND LANC.NREVENTOM = DECODE(LANC.NRTIPOMOVIMENT,  1, DECODE(LANC.NREVENTOM, 205239, 0, 205543, 0, LANC.NREVENTOM), LANC.NREVENTOM) /*Apenas devem vir no movimento 4 (13º sal)*/
          AND GIT.NRITEM != 99 /*Todos os itens, exceto o 'informações complementares'*/
          ".$queryPart."
          AND EXISTS ( SELECT 1
                         FROM FPA_ITECALCFOLHA
                        WHERE NRORG = LANC.NRORG
                          AND NRCALCULOFOLHA = LANC.NRCALCULOFOLHA
                          AND NRVINCULOM = LANC.NRVINCULOM
                          AND NREVENTOM IN (SELECT NREVENTOM FROM FPA_INCIDEVENTO WHERE (NRORG = LANC.NRORG OR NRORG = 0) AND NRTIPOINCIDE = 109)
                          AND VREVENTOFOLHA > 0 )
          )
     WHERE SUBSTR(MES,1,4) = TO_CHAR(TO_DATE(:dtcompetencia), 'yyyy')
  ) PIVOT ( SUM(VREVENTOFOLHA)
            FOR MES IN ('01' AS M01, '02' AS M02, '03' AS M03, '04' AS M04, '05' AS M05, '06' AS M06, '07' AS M07, '08' AS M08, '09' AS M09, '10' AS M10, '11' AS M11, '12' AS M12, '13' AS M13) )
  WHERE CDRECEITA IS NOT NULL /*eventos excluídos não devem ser considerados*/
) PRIN
LEFT JOIN (SELECT
              RES.NRCPFPESSOA,
              LISTAGG(RES.COMPLEMENTO, CHR(13)) WITHIN GROUP (ORDER BY RES.NRCPFPESSOA) COMPLEMENTO
            FROM (SELECT
                      RES.NRCPFPESSOA,
                      DECODE( RES.NREVENTOM, NULL,
                        /*Outras despesas*/
                        'OUTRAS DESPESAS MEDICOODONTOHOSPITALARES: R$' || TO_CHAR(RES.VREVENTOFOLHA, '9g990d00'),
                        /*Operadoras diversas*/
                        CHR(13) || 'Operadora: ' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 1, 3) || '.' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 4, 3) || '.' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 7, 3) || '/' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 10, 4) || '-' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 14, 2) ||
                        ' - ' || RES.NMRAZSOCESTRUT || CHR(13) || 'Valor pago no ano referente ao titular: R$' ||
                        TO_CHAR(RES.VREVENTOFOLHA, '9g990d00') )
                      COMPLEMENTO
                    FROM (SELECT 
                            PH.NRCPFPESSOA, ESH.CDCNPJESTRUT, ESH.NMRAZSOCESTRUT, VEV.NREVENTOM, SUM(LANC.VREVENTOFOLHA) VREVENTOFOLHA
                          FROM LANCAMENTOSVINC_TMP LANC
                          /*CPF e Nome do vínculo em questão (item 3.6)*/
                          JOIN GPE_PESSOAH PH ON PH.NRORG    = LANC.NRORG
                                             AND PH.NRPESSOA = LANC.NRPESSOA
                                             AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                        WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                          AND NRORG    = LANC.NRORG
                                                                          AND NRPESSOA = LANC.NRPESSOA )
                          /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                          JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = LANC.NRORG OR GIN.NRORG = 0 )
                                                   AND GIN.NRGRPINCIDE = :nrgrupoinciden 
                          JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                                                   AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                                                   AND GIT.NRITEM = 99 /*Apenas 'informações complementares'*/
                          JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                                                   AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                                                   AND IEV.NREVENTOM    = LANC.NREVENTOM
                          LEFT JOIN FPA_VINCEVENTO VEV ON VEV.NRORG = LANC.NRORG
                                                 AND VEV.NRVINCULOM = LANC.NRVINCULOM
                                                 AND VEV.NREVENTOM = LANC.NREVENTOM
                                                 AND LANC.DTOCORRENCIA BETWEEN VEV.DTINIVIGENCIA AND NVL(VEV.DTFIMVIGENCIA, LAST_DAY(:dtcompetencia ))
                          LEFT JOIN ESTRUTURAM ESM ON ESM.NRORG        = LANC.NRORG
                                                  AND ESM.NRESTRUTURAM = VEV.NRESTRUTURAM
                          LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG        = LANC.NRORG
                                                  AND ESH.NRESTRUTURAM = ESM.NRESTRUTURAM
                                                  AND ESH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                             WHERE DTMESCOMPETENC <= TO_DATE( :dtcompetencia  ) 
                                                                               AND NRORG        = LANC.NRORG
                                                                               AND NRESTRUTURAM = ESM.NRESTRUTURAM )
                          WHERE LANC.NRORG = :nrorg 
                            AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
                            AND LANC.NRTIPOMOVIMENT = 1
                            --AND LANC.DTOCORRENCIACALC BETWEEN TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) AND :dtcompetencia 
                            ".$regimeQryPart[7]."
                            AND LANC.VREVENTOFOLHA > 0
                            ".$queryPart."
                          GROUP BY PH.NRCPFPESSOA, ESH.CDCNPJESTRUT, ESH.NMRAZSOCESTRUT, VEV.NREVENTOM
                        ) RES
                      UNION ALL
                        SELECT DISTINCT
                          PH.NRCPFPESSOA,
                          'PENSIONISTA: ' || PHD.NRCPFPESSOA || '-' || PHD.NMPESSOA COMPLEMENTO
                        FROM LANCAMENTOSVINC_TMP LANC
                        /*CPF e Nome do vínculo em questão (item 3.6)*/
                        JOIN GPE_PESSOAH PH ON PH.NRORG    = LANC.NRORG
                                           AND PH.NRPESSOA = LANC.NRPESSOA
                                           AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                      WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                        AND NRORG    = LANC.NRORG
                                                                        AND NRPESSOA = LANC.NRPESSOA )
                        /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                        JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = LANC.NRORG OR GIN.NRORG = 0 )
                                                 AND GIN.NRGRPINCIDE = :nrgrupoinciden 
                        JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                                                 AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                                                 AND GIT.NMITEM = 'RTPA' /*Apenas 'pensão alimentícia'*/
                        JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                                                 AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                                                 AND IEV.NREVENTOM    = LANC.NREVENTOM
                        LEFT JOIN FPA_DEPVINCULO DEP ON DEP.NRORG = LANC.NRORG
                                                    AND DEP.NRVINCULOM = LANC.NRVINCULOM
                                                    AND DEP.NRTIPODEPENDE = 3
                        LEFT JOIN GPE_PESSOAH PHD ON PHD.NRORG    = LANC.NRORG
                                                 AND PHD.NRPESSOA = DEP.NRPESSOA
                                                 AND PHD.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                             WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                               AND NRORG    = PHD.NRORG
                                                                               AND NRPESSOA = PHD.NRPESSOA )
                        WHERE LANC.NRORG = :nrorg
                          AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
                          AND LANC.NRTIPOMOVIMENT = 1
                          --AND LANC.DTOCORRENCIA BETWEEN TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) AND :dtcompetencia
                          ".$regimeQryPart[7]."
                          ".$queryPart."
            ) RES
            GROUP BY RES.NRCPFPESSOA
) COMP ON COMP.NRCPFPESSOA = PRIN.NRCPFPESSOA
WHERE PRIN.CDRECEITA IS NOT NULL /*eventos excluídos não devem ser considerados*/
ORDER BY CDRECEITA, CDCPF, DECODE(NMITEM, 'RTPA', 'AAAA', NMITEM)");
        $params['idferias'] =  $idFerias;
        $params['idestagiario'] =  $idEstagiario;
        $params['iddecterceiro'] =  $idDecTerceiro;
        $params['idinforme'] =  $idInforme;
        
        $sql->execute($params);
        
        return $sql->fetchAll();
    }
    
    public function get_motor_hcm($params,$queryPartOld,$queryPart,$idDecTerceiro,$queryPartCdReceita,$idInforme,$idFerias,$idEstagiario,$regimeQryPart){
        $sql = $this->entityManager->getConnection()->prepare("
        /* get_motor_hcm */
        SELECT
  SUM(DECODE(PRIN.NMITEM, 'RTRT',
      ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) + NVL(M13, 0), 2 ), 0)
  ) OVER(PARTITION BY PRIN.NRCPFPESSOA, PRIN.CDRECEITA) TOTAL_RTRT,
  SUM(
    DECODE(PRIN.NMITEM, 'RTIRF',
      ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) + NVL(M13, 0), 2 ), 0)
  ) OVER(PARTITION BY PRIN.NRCPFPESSOA, PRIN.CDRECEITA) TOTAL_RTIRF,
  PRIN.NRTIPOVINCULOM,
  /*PRIN.NRESTRUTLEGAL,*/
  /*PRIN.NRVINCULOM,*/
  PRIN.NRCPFPESSOA,
  /*PRIN.NMVINCULOM,*/
  PRIN.NMPESSOA,
  /*PRIN.DTADMISSAOVINC,*/
  PRIN.NMITEM,
  CASE  /*Verifica se o registro pode ser relacionado no TXT da DIRF*/
    WHEN INSTR(PRIN.NMITEM, :idinforme /*'-INF'*/) > 0 THEN 'N' /*Não aparece no TXT da DIRF*/
    ELSE 'S'
  END FLAG_TXT,
  ROUND( NVL(PRIN.M01, 0) + NVL(PRIN.M02, 0) + NVL(PRIN.M03, 0) + NVL(PRIN.M04, 0) + NVL(PRIN.M05, 0) + NVL(PRIN.M06, 0) + NVL(PRIN.M07, 0) + NVL(PRIN.M08, 0) + NVL(PRIN.M09, 0) + NVL(PRIN.M10, 0) + NVL(PRIN.M11, 0) + NVL(PRIN.M12, 0) /*+ NVL(M13, 0)*/, 2 ) TOTAL,
  ROUND( NVL(PRIN.M13, 0), 2 ) TOTAL13,
  PRIN.IDREC, /*3.5*/
  PRIN.CDRECEITA,
  PRIN.BPFDEC, /*3.6*/
  PRIN.CDCPF,
  PRIN.NOME,
  PRIN.DTMOLESTIA,
  /*5 Indicador de identificação do alimentando; C Fixo 1; S – Existem informações detalhadas do alimentando. N – Não existem informações detalhadas do alimentando.*/
                   /*5 Indicador de identificação do alimentando*/
  'N|' IDPREVCOMP, /*6 Indicador de identificação da previdência complementar; C Fixo 1;*/
  PRIN.CDREGISTRO, /*4.6*/
  SUBSTR( ( ROUND(CASE WHEN PRIN.M01 < 0 THEN 0 ELSE PRIN.M01 END, 2) * 100 ), 1, 13 ) || '|' M01,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M02 < 0 THEN 0 ELSE PRIN.M02 END, 2) * 100 ), 1, 13 ) || '|' M02,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M03 < 0 THEN 0 ELSE PRIN.M03 END, 2) * 100 ), 1, 13 ) || '|' M03,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M04 < 0 THEN 0 ELSE PRIN.M04 END, 2) * 100 ), 1, 13 ) || '|' M04,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M05 < 0 THEN 0 ELSE PRIN.M05 END, 2) * 100 ), 1, 13 ) || '|' M05,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M06 < 0 THEN 0 ELSE PRIN.M06 END, 2) * 100 ), 1, 13 ) || '|' M06,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M07 < 0 THEN 0 ELSE PRIN.M07 END, 2) * 100 ), 1, 13 ) || '|' M07,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M08 < 0 THEN 0 ELSE PRIN.M08 END, 2) * 100 ), 1, 13 ) || '|' M08,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M09 < 0 THEN 0 ELSE PRIN.M09 END, 2) * 100 ), 1, 13 ) || '|' M09,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M10 < 0 THEN 0 ELSE PRIN.M10 END, 2) * 100 ), 1, 13 ) || '|' M10,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M11 < 0 THEN 0 ELSE PRIN.M11 END, 2) * 100 ), 1, 13 ) || '|' M11,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M12 < 0 THEN 0 ELSE PRIN.M12 END, 2) * 100 ), 1, 13 ) || '|' M12,
  SUBSTR( ( ROUND(CASE WHEN PRIN.M13 < 0 THEN 0 ELSE PRIN.M13 END, 2) * 100 ), 1, 13 ) || '|' M13,
  SUBSTR( ( ROUND( CASE WHEN NVL(PRIN.M01, 0) < 0 THEN 0 ELSE NVL(PRIN.M01, 0) END + 
                   CASE WHEN NVL(PRIN.M02, 0) < 0 THEN 0 ELSE NVL(PRIN.M02, 0) END + 
                   CASE WHEN NVL(PRIN.M03, 0) < 0 THEN 0 ELSE NVL(PRIN.M03, 0) END + 
                   CASE WHEN NVL(PRIN.M04, 0) < 0 THEN 0 ELSE NVL(PRIN.M04, 0) END + 
                   CASE WHEN NVL(PRIN.M05, 0) < 0 THEN 0 ELSE NVL(PRIN.M05, 0) END + 
                   CASE WHEN NVL(PRIN.M06, 0) < 0 THEN 0 ELSE NVL(PRIN.M06, 0) END + 
                   CASE WHEN NVL(PRIN.M07, 0) < 0 THEN 0 ELSE NVL(PRIN.M07, 0) END + 
                   CASE WHEN NVL(PRIN.M08, 0) < 0 THEN 0 ELSE NVL(PRIN.M08, 0) END + 
                   CASE WHEN NVL(PRIN.M09, 0) < 0 THEN 0 ELSE NVL(PRIN.M09, 0) END + 
                   CASE WHEN NVL(PRIN.M10, 0) < 0 THEN 0 ELSE NVL(PRIN.M10, 0) END + 
                   CASE WHEN NVL(PRIN.M11, 0) < 0 THEN 0 ELSE NVL(PRIN.M11, 0) END + 
                   CASE WHEN NVL(PRIN.M12, 0) < 0 THEN 0 ELSE NVL(PRIN.M12, 0) END /*+ NVL(M13, 0)*/, 2 ) * 100 ), 1, 13 ) || '|' ANO,
  COMP.COMPLEMENTO
FROM (
  SELECT * FROM ( /*este select é para o pivo funcionar*/
      SELECT
        NRTIPOVINCULOM,
        /*NRESTRUTLEGAL,*/
        NRCPFPESSOA,
        NMPESSOA,
        NMITEM,
        IDREC,
        CDRECEITA,
        BPFDEC,
        CDCPF,
        NOME,
        DTMOLESTIA,
        CDREGISTRO,
        SUBSTR(MES,5,2) MES,
        VREVENTOFOLHA
      FROM (
        SELECT
          /*LANC.NRVINCULOM,*/
          /*LANC.NMVINCULOM,*/
          LANC.NRTIPOVINCULOM,
          /*LANC.NRESTRUTLEGAL,*/
          LANC.NRCPFPESSOA,
          LANC.NMPESSOA,
          /*LANC.DTADMISSAOVINC,*/
          REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, :iddecterceiro /*'-13S'*/, ''), :idferias /*'-FERIAS'*/, ''), :idestagiario /*'-ESTAG'*/, ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') NMITEM, /*Remove a idêntificação do 13º salário (este vai para o M13 e VALOR13)*/
          /*GIT.NRITEM,*/
          'IDREC|'                             IDREC, /*3.5*/
          CASE
            ".$queryPartCdReceita."/*WHEN LANC.NRTIPOVINCULOM = 2 THEN '0588|'*/
            ELSE LPAD(VE.CODRECEITA, 4, '0')   || '|'
          END CDRECEITA,
          'BPFDEC|'                            BPFDEC, /*3.6*/
          LPAD(REPLACE(REPLACE(LANC.NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
          SUBSTR(LANC.NMPESSOA, 1, 60)    || '|' NOME,
          '|'                                  DTMOLESTIA,
          REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(GIT.NMITEM, :iddecterceiro /*'-13S'*/, ''), :idferias /*'-FERIAS'*/, ''), :idestagiario /*'-ESTAG'*/, ''), '-DIFF', ''), '-ADIANT-CX-ANT', ''), '-ADIANT-CX', '') || '|' CDREGISTRO, /*4.6*/
          CASE
            ".$regimeQryPart[0]."
            WHEN INSTR(GIT.NMITEM, :iddecterceiro /*'-13S'*/) > 0 THEN TO_CHAR(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'yyyy')||'13' /*Verifica se o item é do 13º salário (Ex.: se o id13Sal for '-13S' então 'RTRT-13S' é o M13 do 'RTRT')*/
    /*RegimeCaixa*/
            ".$regimeQryPart[1]."
            --WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) AND TO_CHAR(LANC.DTOCORRENCIA, 'yyyy') = TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyy') THEN TO_CHAR(LANC.DTOCORRENCIA, 'yyyymm')
            --WHEN GIT.NMITEM = 'RTPO' AND LANC.NREVENTOM IN (1140,1145) AND TO_CHAR(LANC.DTOCORRENCIA, 'yyyy') <> TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyy') THEN TO_CHAR(LANC.DTOCORRENCIA, 'yyyymm') /*férias partidas que terminam no ano seguinte*/
            WHEN GIT.NMITEM = 'RTPO-FERIAS' AND LANC.NREVENTOM IN (1140) THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyymm')
            WHEN GIT.NMITEM = 'RTPO-FERIAS' AND LANC.NREVENTOM IN (1145) THEN TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyymm')
            ".$regimeQryPart[8]."
            ".$regimeQryPart[2]."
            ELSE TO_CHAR(LANC.DTOCORRENCIACALC, 'yyyymm')
          END MES, /*são as colunas do pivô*/
          CASE
            WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º na rescisao caso não possua data de rescisão*/
            AND LANC.DTRESCISAOVINC IS NULL AND IEV.NREVENTOM IN (600,1180)
            THEN 0
            WHEN GIT.NMITEM IN ('RTRT-13S','RTPO-13S') /*Zera itens do 13º caso possua data de rescisão*/
            AND LANC.DTRESCISAOVINC IS NOT NULL AND LANC.DTRESCISAOVINC <= (TO_DATE(:dtcompetencia)+19) AND IEV.NREVENTOM IN (110,125,1150) /*Rescisoes ate o dia 20 nao tem 13o*/
            THEN 0
            
            WHEN GIT.NMITEM = 'RTPO' /*Zera o RTPO caso o RTRT for zero, pois não há IR, então não há deduções para cálculo de IR*/
            AND (SELECT  SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
                   FROM FPA_ITECALCFOLHA IC
                   JOIN FPA_INCIDEVENTO IE ON (IE.NRORG = 0 OR IE.NRORG = IC.NRORG)
                                          AND IE.NREVENTOM = IC.NREVENTOM
                                          AND IE.NRTIPOINCIDE = 73 /*RTRT*/
                  WHERE IC.NRORG = LANC.NRORG
                    AND IC.NRCALCULOFOLHA = LANC.NRCALCULOFOLHA
                    AND IC.NRVINCULOM = LANC.NRVINCULOM) = 0
            THEN 0
            WHEN GIT.NMITEM IN ('RTRT-ESTAG') /*Zera itens de estagiário quando o tipo de vínculo não for estagiário*/
            AND LANC.NRTIPOVINCULOM <> 2 /*Estagiário*/
            THEN 0
            ".$regimeQryPart[3]."
            ELSE DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * LANC.VREVENTOFOLHA, LANC.VREVENTOFOLHA)) /*Considera o '+' e '-' no sum*/
          END VREVENTOFOLHA
        FROM LANCAMENTOSVINC_DIRF LANC
        /*Código da receita do vínculo em questão (item 3.5)*/
        LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = LANC.NRVINCULOEMPREG
        /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
        JOIN (SELECT GIT.NRORG, GIT.NRITEM, GIT.NMITEM, GIT.NRGRPINCIDE, GIT.NRTIPOINCIDE
                FROM FPA_GRPITEM GIT
               WHERE (GIT.NRORG = :nrorg /*:P_NRORG*/ OR GIT.NRORG = 0)
                                 AND GIT.NRGRPINCIDE  = :nrgrupoinciden /*:P_NRGRPDIRF*/
    /*RegimeCaixa*/
              ".$regimeQryPart[4]." ) GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                                         AND GIT.NRGRPINCIDE  = :nrgrupoinciden /*:P_NRGRPDIRF*/
        JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                                 AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                                 AND IEV.NREVENTOM      = LANC.NREVENTOM
        WHERE LANC.NRORG = :nrorg
          AND ( LANC.DTRESCISAOVINC IS NULL
                OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) ) )
          AND ( /*LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 1)
               OR */LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIAP-DIFF', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 19)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idFerias."', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idEstagiario."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idFerias."', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
               /*OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)*/
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTRT".$idDecTerceiro.$idInforme."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPO".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 8)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF".$idDecTerceiro."', 4)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 10)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTIRF', 2)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIDAC', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIIRP', 1)
               OR LANC.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RIO', 1)
    /*RegimeCaixa*/
               ".$regimeQryPart[5]." )
         ".$regimeQryPart[6]."
          AND LANC.NREVENTOM = DECODE(LANC.NRTIPOMOVIMENT, 10, DECODE(LANC.NREVENTOM, 475, 475, DECODE(LANC.DTOCORRENCIACALC, TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 1390, 0)), LANC.NREVENTOM)
          AND LANC.NREVENTOM = DECODE(LANC.NRTIPOMOVIMENT,  1, DECODE(LANC.NREVENTOM, 205239, 0, 205543, 0, LANC.NREVENTOM), LANC.NREVENTOM) /*Apenas devem vir no movimento 4 (13º sal)*/
          AND GIT.NRITEM != 99 /*Todos os itens, exceto o 'informações complementares'*/
          ".$queryPart."
          AND EXISTS ( SELECT 1
                         FROM FPA_ITECALCFOLHA
                        WHERE NRORG = LANC.NRORG
                          AND NRCALCULOFOLHA = LANC.NRCALCULOFOLHA
                          AND NRVINCULOM = LANC.NRVINCULOM
                          AND NREVENTOM IN (SELECT NREVENTOM FROM FPA_INCIDEVENTO WHERE (NRORG = LANC.NRORG OR NRORG = 0) AND NRTIPOINCIDE = 109)
                          AND VREVENTOFOLHA > 0 )
          )
     WHERE SUBSTR(MES,1,4) = TO_CHAR(TO_DATE(:dtcompetencia), 'yyyy')
  ) PIVOT ( SUM(VREVENTOFOLHA)
            FOR MES IN ('01' AS M01, '02' AS M02, '03' AS M03, '04' AS M04, '05' AS M05, '06' AS M06, '07' AS M07, '08' AS M08, '09' AS M09, '10' AS M10, '11' AS M11, '12' AS M12, '13' AS M13) )
  WHERE CDRECEITA IS NOT NULL /*eventos excluídos não devem ser considerados*/
) PRIN
LEFT JOIN (SELECT
              RES.NRCPFPESSOA,
              LISTAGG(RES.COMPLEMENTO, CHR(13)) WITHIN GROUP (ORDER BY RES.NRCPFPESSOA) COMPLEMENTO
            FROM (SELECT
                      RES.NRCPFPESSOA,
                      DECODE( RES.NREVENTOM, NULL,
                        /*Outras despesas*/
                        'OUTRAS DESPESAS MEDICOODONTOHOSPITALARES: R$' || TO_CHAR(RES.VREVENTOFOLHA, '9g990d00'),
                        /*Operadoras diversas*/
                        CHR(13) || 'Operadora: ' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 1, 3) || '.' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 4, 3) || '.' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 7, 3) || '/' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 10, 4) || '-' ||
                        SUBSTR(LPAD(RES.CDCNPJESTRUT, 15, '0'), 14, 2) ||
                        ' - ' || RES.NMRAZSOCESTRUT || CHR(13) || 'Valor pago no ano referente ao titular: R$' ||
                        TO_CHAR(RES.VREVENTOFOLHA, '9g990d00') )
                      COMPLEMENTO
                    FROM (SELECT 
                            LANC.NRCPFPESSOA, ESH.CDCNPJESTRUT, ESH.NMRAZSOCESTRUT, VEV.NREVENTOM, SUM(LANC.VREVENTOFOLHA) VREVENTOFOLHA
                          FROM LANCAMENTOSVINC_DIRF LANC
                          /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                          JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = LANC.NRORG OR GIN.NRORG = 0 )
                                                   AND GIN.NRGRPINCIDE = :nrgrupoinciden 
                          JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                                                   AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                                                   AND GIT.NRITEM = 99 /*Apenas 'informações complementares'*/
                          JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                                                   AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                                                   AND IEV.NREVENTOM    = LANC.NREVENTOM
                          LEFT JOIN FPA_VINCEVENTO VEV ON VEV.NRORG = LANC.NRORG
                                                 AND VEV.NRVINCULOM = LANC.NRVINCULOM
                                                 AND VEV.NREVENTOM = LANC.NREVENTOM
                                                 AND LANC.DTOCORRENCIA BETWEEN VEV.DTINIVIGENCIA AND NVL(VEV.DTFIMVIGENCIA, LAST_DAY(:dtcompetencia ))
                          LEFT JOIN ESTRUTURAM ESM ON ESM.NRORG        = LANC.NRORG
                                                  AND ESM.NRESTRUTURAM = VEV.NRESTRUTURAM
                          LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG        = LANC.NRORG
                                                  AND ESH.NRESTRUTURAM = ESM.NRESTRUTURAM
                                                  AND ESH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                             WHERE DTMESCOMPETENC <= TO_DATE( :dtcompetencia  ) 
                                                                               AND NRORG        = LANC.NRORG
                                                                               AND NRESTRUTURAM = ESM.NRESTRUTURAM )
                          WHERE LANC.NRORG = :nrorg 
                            AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
                            AND LANC.NRTIPOMOVIMENT = 1
                            --AND LANC.DTOCORRENCIACALC BETWEEN TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) AND :dtcompetencia 
                            ".$regimeQryPart[7]."
                            AND LANC.VREVENTOFOLHA > 0
                            ".$queryPart."
                          GROUP BY LANC.NRCPFPESSOA, ESH.CDCNPJESTRUT, ESH.NMRAZSOCESTRUT, VEV.NREVENTOM
                        ) RES
                      UNION ALL
                        SELECT DISTINCT
                          LANC.NRCPFPESSOA,
                          'PENSIONISTA: ' || PHD.NRCPFPESSOA || '-' || PHD.NMPESSOA COMPLEMENTO
                        FROM LANCAMENTOSVINC_DIRF LANC
                        /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
                        JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = LANC.NRORG OR GIN.NRORG = 0 )
                                                 AND GIN.NRGRPINCIDE = :nrgrupoinciden 
                        JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                                                 AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                                                 AND GIT.NMITEM = 'RTPA' /*Apenas 'pensão alimentícia'*/
                        JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                                                 AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                                                 AND IEV.NREVENTOM    = LANC.NREVENTOM
                        LEFT JOIN FPA_DEPVINCULO DEP ON DEP.NRORG = LANC.NRORG
                                                    AND DEP.NRVINCULOM = LANC.NRVINCULOM
                                                    AND DEP.NRTIPODEPENDE = 3
                        LEFT JOIN GPE_PESSOAH PHD ON PHD.NRORG    = LANC.NRORG
                                                 AND PHD.NRPESSOA = DEP.NRPESSOA
                                                 AND PHD.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                             WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                                               AND NRORG    = PHD.NRORG
                                                                               AND NRPESSOA = PHD.NRPESSOA )
                        WHERE LANC.NRORG = :nrorg
                          AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
                          AND LANC.NRTIPOMOVIMENT = 1
                          --AND LANC.DTOCORRENCIA BETWEEN TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) AND :dtcompetencia
                          ".$regimeQryPart[7]."
                          ".$queryPart."
            ) RES
            GROUP BY RES.NRCPFPESSOA
) COMP ON COMP.NRCPFPESSOA = PRIN.NRCPFPESSOA
WHERE PRIN.CDRECEITA IS NOT NULL /*eventos excluídos não devem ser considerados*/
ORDER BY CDRECEITA, CDCPF, DECODE(NMITEM, 'RTPA', 'AAAA', NMITEM)");
        $params['idferias'] =  $idFerias;
        $params['idestagiario'] =  $idEstagiario;
        $params['iddecterceiro'] =  $idDecTerceiro;
        $params['idinforme'] =  $idInforme;
        
        $sql->execute($params);
        
        return $sql->fetchAll();
    }
    
    public function get_infpa($params){
        $sql = $this->entityManager->getConnection()->prepare(
        "SELECT DISTINCT
  'INFPA|' INFPA,
  LPAD(REPLACE(REPLACE(PHD.NRCPFPESSOA,'.',''),'-',''), 11, '0')        || '|' CDCPFDEP,
  TO_CHAR(PHD.DTNASCPESSOA ,'YYYYMMDD') || '|' DTNASCDEP,
  SUBSTR(PHD.NMPESSOA, 1, 60)           || '|' NOMEDEP,
  LPAD(NVL(DECODE(RP.NRTIPORELACIONA, 1, '08', 2, '08', 3, '04', 4, '03', 7, '03', '10'), '0'), 2, '0') || '|' RELACDEP
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
                    AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                               WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                 AND NRORG      = VM.NRORG
                                                 AND NRVINCULOM = VM.NRVINCULOM )
JOIN GPE_PESSOA PE ON PE.NRORG    = VM.NRORG
                  AND PE.NRPESSOA = VM.NRPESSOA
JOIN GPE_PESSOAH PH ON PH.NRORG    = VM.NRORG
                   AND PH.NRPESSOA = VM.NRPESSOA
                   AND PH.NRCPFPESSOA = :cpftitular
                   AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                              WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                AND NRORG    = VM.NRORG
                                                AND NRPESSOA = VM.NRPESSOA )
JOIN FPA_DEPVINCULO DEP ON DEP.NRORG = VM.NRORG
                       AND DEP.NRVINCULOM = VM.NRVINCULOM
                       AND DEP.NRTIPODEPENDE = 3
JOIN GPE_PESSOA PED ON PED.NRORG    = VM.NRORG
                   AND PED.NRPESSOA = DEP.NRPESSOA
JOIN GPE_PESSOAH PHD ON PHD.NRORG    = VM.NRORG
                    AND PHD.NRPESSOA = DEP.NRPESSOA
                    AND PHD.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                  AND NRORG    = PHD.NRORG
                                                  AND NRPESSOA = PHD.NRPESSOA )
LEFT JOIN RELACIONAPARC RP ON RP.NRORG = PH.NRORG
                          AND RP.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                          AND RP.NRPARCNEGRELAC = PED.NRPARCNEGOCIO
WHERE VM.NRORG = :nrorg 
  AND ( VM.DTRESCISAOVINC <> VM.DTADMISSAOVINC OR VM.DTRESCISAOVINC IS NULL )
  AND ( VM.DTRESCISAOVINC IS NULL OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
ORDER BY 2,3"    
        ); 
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_infpa_aux($params){
		$sql = $this->entityManager->getConnection()->prepare(
"SELECT
  1
FROM GPE_VINCULOM VM
--CPF e Nome do vínculo em questão (item 3.6)
JOIN GPE_PESSOAH PH ON PH.NRORG    = VM.NRORG
                   AND PH.NRPESSOA = VM.NRPESSOA
                   AND PH.NRCPFPESSOA = :cpftitular
                   AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                              WHERE DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                                AND NRORG    = VM.NRORG
                                                AND NRPESSOA = VM.NRPESSOA )
JOIN FPA_DEPVINCULO DEP ON DEP.NRORG = VM.NRORG
                       AND DEP.NRVINCULOM = VM.NRVINCULOM
                       AND DEP.NRTIPODEPENDE = 3
WHERE VM.NRORG = :nrorg /*:P_NRORG*/
  AND ( VM.DTRESCISAOVINC <> VM.DTADMISSAOVINC OR VM.DTRESCISAOVINC IS NULL )
  AND ( VM.DTRESCISAOVINC IS NULL OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/ ), 'YEAR' ) ) )"
		);
		$sql->execute($params);
        return $sql->fetchAll();
	}
    
    public function get_pse_apurabeneficio($params,$queryPart,$queryPartPse){
        $sql = $this->entityManager->getConnection()->prepare("
/* get_pse_apurabeneficio */
SELECT
  CDCNPJESTRUT,
  NRCPFPESSOA,
  DTNASCPESSOADEP,
  PSE,
  OPSE,
  CNPJ_EMPR,
  NOME_EMPR,
  REG_ANS,
  TPSE,
  CDCPF,
  NOME,
  SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,
  DTPSE,
  CDCPFDEP,
  DTNASCDEP,
  NOMEDEP,
  RELACDEP,
  SUBSTR(ROUND(SUM(VALORDEP), 2) * 100, 1, 13) || '|' VALORDEP,
  NRCPFTITULAR
FROM (SELECT
      CDCNPJESTRUT,
      NRCPFPESSOA,
      DTNASCPESSOADEP,
      'PSE|' PSE,
      'OPSE|' OPSE,
      CDCNPJESTRUT || '|' CNPJ_EMPR,
      SUBSTR(REPLACE(REPLACE(REPLACE(NMRAZSOCESTRUT,'.'),'/'),'-'), 1, 150) || '|' NOME_EMPR,
      REPLACE(CDFEDERALESTRUT, '-', '') || '|' REG_ANS,
      'TPSE|' TPSE,
      LPAD(REPLACE(REPLACE(NRCPFTITULAR,'.',''),'-',''), 11, '0') || '|' CDCPF,
      SUBSTR(REPLACE(REPLACE(REPLACE(NMPESSOA,'.'),'/'),'-'), 1, 60) || '|' NOME,
      /*SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,*/ VALOR,
      'DTPSE|' DTPSE,
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOADEP,'.',''),'-',''), '0'), 11, '0') || '|' CDCPFDEP,
      LPAD(TO_CHAR(DTNASCPESSOADEP, 'YYYYMMDD'), 8, '0') || '|' DTNASCDEP,
      SUBSTR(REPLACE(REPLACE(REPLACE(NMPESSOADEP,'.'),'/'),'-'), 1, 60) || '|' NOMEDEP,
      LPAD(NVL(DECODE(NRTIPORELACIONA, 1, '08', /*Mae*/
                                       2, '08', /*Pai*/
                                       3, '04', /*Filho(a) ou enteado(a)*/
                                       4, '03', /*Conjuge*/
                                       7, '03', /*Companheiro(a) c/ o(a) qual...*/
                                       '10'), '0'), 2, '0') || '|' RELACDEP,
      /*SUBSTR(ROUND(VALORDEP / DECODE(QTDEP, 0, 1, QTDEP), 2) * 100, 1, 13) || '|' VALORDEP,*/
      VALORDEP,
      NRCPFTITULAR,
      IDTPBENEFICIARIO
    FROM (
          SELECT
    			EHB.CDCNPJESTRUT,
    			TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
    			EHB.CDFEDERALESTRUT,
    			PEH.NRCPFPESSOA,
    			PEHT.NRCPFPESSOA NRCPFTITULAR,
    			PEHT.NMPESSOA,
    			SUM(DECODE(BF.IDTPBENEFICIARIO, 'T', AB.VRAPURABENEFICIO, 0))  VALOR,
    			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
    			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
    			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
    			R.NRTIPORELACIONA                                         NRTIPORELACIONA,
    			SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', AB.VRAPURABENEFICIO, 0))  VALORDEP,
    			COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY AB.NRVINCULOM, CF.DTOCORRENCIA, AB.NRBENEFICIOM) QTDEP,
                BF.IDTPBENEFICIARIO
			/*Itens de cálculo*/
			FROM FPA_CALCULOFOLHA CF
			JOIN VAB_APURABENEFICIO AB ON AB.NRORG           = CF.NRORG
									  AND AB.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
			                          AND AB.DSTIPOBENEFICIO = 'V'
			/*Pessoa Geral*/
			JOIN GPE_PESSOAH PEH ON PEH.NRORG          = AB.NRORG
								AND PEH.NRPESSOA       = AB.NRPESSOA
								AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
														WHERE NRORG    = AB.NRORG
															AND NRPESSOA = PEH.NRPESSOA
															AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
			JOIN GPE_PESSOA PE ON PE.NRORG    = PEH.NRORG
							AND PE.NRPESSOA = PEH.NRPESSOA
			/*Pessoa Titular*/
			JOIN GPE_VINCULOM VM ON VM.NRORG      = AB.NRORG
								AND VM.NRVINCULOM = AB.NRVINCULOM
		    JOIN GPE_VINCULOH VH ON VH.NRORG          = VM.NRORG
							AND VH.NRVINCULOM     = VM.NRVINCULOM
							AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH GPE_VINCULOH1
														WHERE DTMESCOMPETENC <= CF.DTOCORRENCIA
														AND NRORG           = VM.NRORG
														AND NRVINCULOM      = VM.NRVINCULOM )							
			JOIN GPE_PESSOA PET ON PET.NRORG    = VM.NRORG
							AND PET.NRPESSOA = VM.NRPESSOA
			JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
								AND PEHT.NRPESSOA       = PET.NRPESSOA
								AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
															WHERE NRORG    = PET.NRORG
															AND NRPESSOA = PEHT.NRPESSOA
															AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
			LEFT JOIN RELACIONAPARC R ON R.NRORG          = AB.NRORG
									AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
									AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
			/*Benefício*/
			JOIN VAB_BENEFICIARIO BF ON BF.NRORG            = AB.NRORG
									AND BF.NRBENEFICIOM     = AB.NRBENEFICIOM
									AND BF.NRVINCULOM       = AB.NRVINCULOM
									AND BF.NRPESSOA         = AB.NRPESSOA
			JOIN VAB_BENEFICIOH BH ON BH.NRORG          = AB.NRORG
								AND BH.NRBENEFICIOM   = AB.NRBENEFICIOM
								AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
															WHERE NRORG        = BH.NRORG
															AND NRBENEFICIOM = BH.NRBENEFICIOM
															AND DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/ )
			/*Operadora do benefício Titular*/
			LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BH.NRORG
							AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
							AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
														WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
															AND DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
															AND NRORG           = EHB.NRORG)
			/**/
		   WHERE CF.NRORG = :nrorg /*:P_NRORG*/
		     AND CF.NRTIPOMOVIMENT = 21 /*Movimentos mensal*/
             AND CF.NRTPMODALIDCAL = 1 /*Real*/
             AND CF.NRTPMODALIDCAL = :nrcenario /*Cenário real apenas*/
             AND EHB.CDFEDERALESTRUT IS NOT NULL
			 ".$queryPartPse."
			 ".$queryPart."
		   GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT, PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEHT.NMPESSOA,
			BF.IDTPBENEFICIARIO, PEH.DTNASCPESSOA, PEH.NMPESSOA, AB.NRVINCULOM, CF.DTOCORRENCIA, AB.NRBENEFICIOM, R.NRTIPORELACIONA
		  UNION ALL 
          SELECT 
              EHB.CDCNPJESTRUT,
              TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
              EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA,
              PEHT.NRCPFPESSOA NRCPFTITULAR,
              PEHT.NMPESSOA,
              SUM(DECODE(BF.IDTPBENEFICIARIO, 'T', ICF.VREVENTOFOLHA, 0))  VALOR,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
              R.NRTIPORELACIONA                                         NRTIPORELACIONA,
              SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', ICF.VREVENTOFOLHA, 0))  VALORDEP,
              COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY VM.NRVINCULOM, ICF.DTOCORRENCIA, EHB.CDCNPJESTRUT) QTDEP,
              BF.IDTPBENEFICIARIO
            FROM GPE_VINCULOM VM
            /*Benefício*/
            JOIN VAB_BENEFICIARIO BF ON BF.NRORG      = VM.NRORG
                                    AND BF.NRVINCULOM = VM.NRVINCULOM
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = VM.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            /*Cálculo*/
            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = :nrorg /*:P_NRORG*/
                                    AND CF.NRTIPOMOVIMENT = 1 /*Movimentos mensal*/
                                    AND CF.NRTPMODALIDCAL = 1 /*Real*/
                                    AND CF.NRTPMODALIDCAL = :nrcenario /*Cenário real apenas*/
                                    ".$queryPartPse."
                                    AND CF.DTOCORRENCIA >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                                    AND CF.DTOCORRENCIA <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/))
            JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = VM.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= DT.DTDATA )
            /*Itens de cálculo*/
            JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                     AND ICF.NRVINCULOM     = VM.NRVINCULOM
                                     AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                     AND ICF.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP) ) /*Parte co-participação      */
            /*Vínculo*/
            JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                AND VH.NRVINCULOM = VM.NRVINCULOM
                                AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                          WHERE DTMESCOMPETENC <= DT.DTDATA
                                                            AND NRORG           = VM.NRORG
                                                            AND NRVINCULOM      = VM.NRVINCULOM )
            /*Pessoa Titular*/
            JOIN GPE_PESSOA PET ON PET.NRORG    = VM.NRORG
                               AND PET.NRPESSOA = VM.NRPESSOA
            JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
                                 AND PEHT.NRPESSOA       = PET.NRPESSOA
                                 AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                             WHERE NRORG           = PEHT.NRORG
                                                               AND NRPESSOA        = PEHT.NRPESSOA
                                                               AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            /*Pessoa Dependente*/
            JOIN GPE_PESSOA PE ON PE.NRORG    = VM.NRORG
                              AND PE.NRPESSOA = BF.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                AND PEH.NRPESSOA       = PE.NRPESSOA
                                AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                           WHERE NRORG           = PEH.NRORG
                                                             AND NRPESSOA        = PEH.NRPESSOA
                                                             AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            LEFT JOIN RELACIONAPARC R ON R.NRORG          = VM.NRORG
                                     AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                                     AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE VM.NRORG = :nrorg /*:P_NRORG*/
              AND EHB.CDFEDERALESTRUT IS NOT NULL
              AND ICF.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,ICF.DTOCORRENCIA)
              ".$queryPart."
            GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEHT.NMPESSOA, PEH.NMPESSOA, BF.IDTPBENEFICIARIO,
              PEH.DTNASCPESSOA, R.NRTIPORELACIONA, VM.NRVINCULOM, ICF.DTOCORRENCIA
    )
    WHERE VALOR > 0 OR VALORDEP > 0
)
GROUP BY CDCNPJESTRUT, NRCPFPESSOA, DTNASCPESSOADEP, PSE, OPSE, CNPJ_EMPR, NOME_EMPR, REG_ANS, TPSE, CDCPF, NOME, DTPSE, CDCPFDEP, DTNASCDEP, NOMEDEP, RELACDEP, NRCPFTITULAR, IDTPBENEFICIARIO
ORDER BY CNPJ_EMPR, NRCPFTITULAR, IDTPBENEFICIARIO DESC, CDCPFDEP
"
            );
            
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_pse_apurabeneficio2($params,$queryPart,$queryPartPse){
        $sql = $this->entityManager->getConnection()->prepare("
/* get_pse_apurabeneficio2 */
SELECT
  CDCNPJESTRUT,
  NRCPFPESSOA,
  DTNASCPESSOADEP,
  PSE,
  OPSE,
  CNPJ_EMPR,
  NOME_EMPR,
  REG_ANS,
  TPSE,
  CDCPF,
  NOME,
  SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,
  DTPSE,
  CDCPFDEP,
  DTNASCDEP,
  NOMEDEP,
  RELACDEP,
  SUBSTR(ROUND(SUM(VALORDEP), 2) * 100, 1, 13) || '|' VALORDEP,
  NRCPFTITULAR
FROM (SELECT
      CDCNPJESTRUT,
      NRCPFPESSOA,
      DTNASCPESSOADEP,
      'PSE|' PSE,
      'OPSE|' OPSE,
      CDCNPJESTRUT || '|' CNPJ_EMPR,
      SUBSTR(NMRAZSOCESTRUT, 1, 150) || '|' NOME_EMPR,
      REPLACE(CDFEDERALESTRUT, '-', '') || '|' REG_ANS,
      'TPSE|' TPSE,
      LPAD(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
      SUBSTR(NMPESSOA, 1, 60) || '|' NOME,
      /*SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,*/ VALOR,
      'DTPSE|' DTPSE,
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOADEP,'.',''),'-',''), '0'), 11, '0') || '|' CDCPFDEP,
      LPAD(TO_CHAR(DTNASCPESSOADEP, 'YYYYMMDD'), 8, '0') || '|' DTNASCDEP,
      SUBSTR(NMPESSOADEP, 1, 60) || '|' NOMEDEP,
      LPAD(NVL(DECODE(NRTIPORELACIONA, 1, '08', /*Mae*/
                                       2, '08', /*Pai*/
                                       3, '04', /*Filho(a) ou enteado(a)*/
                                       4, '03', /*Conjuge*/
                                       7, '03', /*Companheiro(a) c/ o(a) qual...*/
                                       '10'), '0'), 2, '0') || '|' RELACDEP,
      /*SUBSTR(ROUND(VALORDEP / DECODE(QTDEP, 0, 1, QTDEP), 2) * 100, 1, 13) || '|' VALORDEP,*/
      VALORDEP,
      NRCPFTITULAR,
      IDTPBENEFICIARIO
    FROM (
          SELECT
    			EHB.CDCNPJESTRUT,
    			EHB.NMRAZSOCESTRUT,
    			EHB.CDFEDERALESTRUT,
    			PEH.NRCPFPESSOA,
    			PEHT.NRCPFPESSOA NRCPFTITULAR,
    			PEH.NMPESSOA,
    			SUM(AB.VRAPURABENEFICIO) VALOR,
    			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
    			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
    			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
    			R.NRTIPORELACIONA                                         NRTIPORELACIONA,
    			SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', AB.VRAPURABENEFICIO, 0))  VALORDEP,
    			COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY AB.NRVINCULOM, CF.DTOCORRENCIA, AB.NRBENEFICIOM) QTDEP,
                BF.IDTPBENEFICIARIO
			/*Itens de cálculo*/
			FROM FPA_CALCULOFOLHA CF
			JOIN VAB_APURABENEFICIO AB ON AB.NRORG           = CF.NRORG
									  AND AB.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
			                          AND AB.DSTIPOBENEFICIO = 'V'
			/*Pessoa Geral*/
        			JOIN GPE_PESSOA PE ON PE.NRORG    = AB.NRORG
        							          AND PE.NRPESSOA = AB.NRPESSOA
        			JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                  								AND PEH.NRPESSOA       = PE.NRPESSOA
                  								AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                  														WHERE NRORG    = PEH.NRORG
                                  															AND NRPESSOA = PEH.NRPESSOA
                                  															AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
			/*Pessoa Titular*/
			JOIN GPE_VINCULOM VM ON VM.NRORG      = AB.NRORG
								AND VM.NRVINCULOM = AB.NRVINCULOM
		    JOIN GPE_VINCULOH VH ON VH.NRORG          = VM.NRORG
							AND VH.NRVINCULOM     = VM.NRVINCULOM
							AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH GPE_VINCULOH1
														WHERE DTMESCOMPETENC <= CF.DTOCORRENCIA
														AND NRORG           = VM.NRORG
														AND NRVINCULOM      = VM.NRVINCULOM )							
			JOIN GPE_PESSOA PET ON PET.NRORG    = VM.NRORG
							AND PET.NRPESSOA = VM.NRPESSOA
			JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
								AND PEHT.NRPESSOA       = PET.NRPESSOA
								AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
															WHERE NRORG    = PET.NRORG
															AND NRPESSOA = PEHT.NRPESSOA
															AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
			LEFT JOIN RELACIONAPARC R ON R.NRORG          = AB.NRORG
									AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
									AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
			/*Benefício*/
			JOIN VAB_BENEFICIARIO BF ON BF.NRORG            = AB.NRORG
									AND BF.NRBENEFICIOM     = AB.NRBENEFICIOM
									AND BF.NRVINCULOM       = AB.NRVINCULOM
									AND BF.NRPESSOA         = AB.NRPESSOA
			JOIN VAB_BENEFICIOH BH ON BH.NRORG          = AB.NRORG
								AND BH.NRBENEFICIOM   = AB.NRBENEFICIOM
								AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
															WHERE NRORG        = BH.NRORG
															AND NRBENEFICIOM = BH.NRBENEFICIOM
															AND DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/ )
			/*Operadora do benefício Titular*/
			LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BH.NRORG
							AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
							AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
														WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
															AND DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
															AND NRORG           = EHB.NRORG)
			/**/
		   WHERE CF.NRORG = :nrorg /*:P_NRORG*/
		     AND CF.NRTIPOMOVIMENT = 21 /*Movimentos mensal*/
             AND CF.NRTPMODALIDCAL = 1 /*Real*/
             AND CF.NRTPMODALIDCAL = :nrcenario /*Cenário real apenas*/
			 ".$queryPartPse."
			 ".$queryPart."
		   GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT, PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEH.NMPESSOA,
			BF.IDTPBENEFICIARIO, PEH.DTNASCPESSOA, PEH.NMPESSOA, AB.NRVINCULOM, CF.DTOCORRENCIA, AB.NRBENEFICIOM, R.NRTIPORELACIONA
		  UNION ALL 
          SELECT
              EHB.CDCNPJESTRUT,
              TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
              EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA,
              PEHT.NRCPFPESSOA NRCPFTITULAR,
              PEH.NMPESSOA,
              SUM(LANC.VREVENTOFOLHA) VALOR,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
              R.NRTIPORELACIONA                                         NRTIPORELACIONA,
              SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', LANC.VREVENTOFOLHA, 0))  VALORDEP,
              COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY LANC.NRVINCULOM, LANC.DTOCORRENCIA, EHB.CDCNPJESTRUT) QTDEP,
              BF.IDTPBENEFICIARIO
            FROM LANCAMENTOSVINC_TMP LANC
            /*Benefício*/
            JOIN VAB_BENEFICIARIO BF ON BF.NRORG      = LANC.NRORG
                                    AND BF.NRVINCULOM = LANC.NRVINCULOM
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = LANC.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = LANC.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= LANC.DTOCORRENCIACALC )
            /*Pessoa Titular*/
            JOIN GPE_PESSOA PET ON PET.NRORG    = LANC.NRORG
                               AND PET.NRPESSOA = LANC.NRPESSOA
            JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
                                 AND PEHT.NRPESSOA       = PET.NRPESSOA
                                 AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                             WHERE NRORG           = PEHT.NRORG
                                                               AND NRPESSOA        = PEHT.NRPESSOA
                                                               AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            /*Pessoa Dependente*/
            JOIN GPE_PESSOA PE ON PE.NRORG    = LANC.NRORG
                              AND PE.NRPESSOA = BF.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                AND PEH.NRPESSOA       = PE.NRPESSOA
                                AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                           WHERE NRORG           = PEH.NRORG
                                                             AND NRPESSOA        = PEH.NRPESSOA
                                                             AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            LEFT JOIN RELACIONAPARC R ON R.NRORG          = LANC.NRORG
                                     AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                                     AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE LANC.NRORG = :nrorg /*:P_NRORG*/
            AND LANC.NRTIPOMOVIMENT = 1 /*Movimentos mensal*/
            AND LANC.DTOCORRENCIACALC >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
            AND LANC.DTOCORRENCIACALC <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/))
            ".str_replace("CF.DTOCORRENCIA","LANC.DTOCORRENCIACALC",$queryPartPse)."
            AND LANC.NREVENTOM IN DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART, BH.NREVENTOCOPARTDEP) /*Parte co-participação      */
            AND EHB.CDFEDERALESTRUT IS NOT NULL
            AND LANC.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,LANC.DTOCORRENCIA)
            ".str_replace("VH.","LANC.",str_replace("VM.","LANC.",$queryPart))."
            GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEH.NMPESSOA, BF.IDTPBENEFICIARIO,
              PEH.DTNASCPESSOA, R.NRTIPORELACIONA, LANC.NRVINCULOM, LANC.DTOCORRENCIA
    )
    WHERE VALOR > 0
)
GROUP BY CDCNPJESTRUT, NRCPFPESSOA, DTNASCPESSOADEP, PSE, OPSE, CNPJ_EMPR, NOME_EMPR, REG_ANS, TPSE, CDCPF, NOME, DTPSE, CDCPFDEP, DTNASCDEP, NOMEDEP, RELACDEP, NRCPFTITULAR, IDTPBENEFICIARIO
ORDER BY CNPJ_EMPR, NRCPFTITULAR, IDTPBENEFICIARIO DESC, CDCPFDEP
"
            );
            
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_pse_apurabeneficio_hcm($params,$queryPart,$queryPartPse){
        $sql = $this->entityManager->getConnection()->prepare("
/* get_pse_apurabeneficio_hcm */
SELECT
  CDCNPJESTRUT,
  NRCPFPESSOA,
  DTNASCPESSOADEP,
  PSE,
  OPSE,
  CNPJ_EMPR,
  NOME_EMPR,
  REG_ANS,
  TPSE,
  CDCPF,
  NOME,
  SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,
  DTPSE,
  CDCPFDEP,
  DTNASCDEP,
  NOMEDEP,
  RELACDEP,
  SUBSTR(ROUND(SUM(VALORDEP), 2) * 100, 1, 13) || '|' VALORDEP,
  NRCPFTITULAR
FROM (SELECT
        CDCNPJESTRUT,
        NRCPFPESSOA,
        DTNASCPESSOADEP,
        'PSE|' PSE,
        'OPSE|' OPSE,
        CDCNPJESTRUT || '|' CNPJ_EMPR,
        SUBSTR(NMRAZSOCESTRUT, 1, 150) || '|' NOME_EMPR,
        REPLACE(CDFEDERALESTRUT, '-', '') || '|' REG_ANS,
        'TPSE|' TPSE,
        LPAD(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
        SUBSTR(NMPESSOA, 1, 60) || '|' NOME,
        /*SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,*/ VALOR,
        'DTPSE|' DTPSE,
        LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOADEP,'.',''),'-',''), '0'), 11, '0') || '|' CDCPFDEP,
        LPAD(TO_CHAR(DTNASCPESSOADEP, 'YYYYMMDD'), 8, '0') || '|' DTNASCDEP,
        SUBSTR(NMPESSOADEP, 1, 60) || '|' NOMEDEP,
        LPAD(NVL(DECODE(NRTIPORELACIONA, 1, '08', /*Mae*/
                                         2, '08', /*Pai*/
                                         3, '04', /*Filho(a) ou enteado(a)*/
                                         4, '03', /*Conjuge*/
                                         7, '03', /*Companheiro(a) c/ o(a) qual...*/
                                         '10'), '0'), 2, '0') || '|' RELACDEP,
        /*SUBSTR(ROUND(VALORDEP / DECODE(QTDEP, 0, 1, QTDEP), 2) * 100, 1, 13) || '|' VALORDEP,*/
        VALORDEP,
        NRCPFTITULAR,
        IDTPBENEFICIARIO
      FROM (
            SELECT
          			EHB.CDCNPJESTRUT,
          			EHB.NMRAZSOCESTRUT,
          			EHB.CDFEDERALESTRUT,
          			PEH.NRCPFPESSOA,
          			PEHT.NRCPFPESSOA NRCPFTITULAR,
          			PEH.NMPESSOA,
          			SUM(AB.VRAPURABENEFICIO) VALOR,
          			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
          			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
          			DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
          			R.NRTIPORELACIONA                                         NRTIPORELACIONA,
          			SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', AB.VRAPURABENEFICIO, 0))  VALORDEP,
          			COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY AB.NRVINCULOM, CF.DTOCORRENCIA, AB.NRBENEFICIOM) QTDEP,
                      BF.IDTPBENEFICIARIO
        			/*Itens de cálculo*/
        			FROM FPA_CALCULOFOLHA CF
        			JOIN VAB_APURABENEFICIO AB ON AB.NRORG           = CF.NRORG
        									              AND AB.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
        			                          AND AB.DSTIPOBENEFICIO = 'V'
        			/*Pessoa Geral*/
        			JOIN GPE_PESSOA PE ON PE.NRORG    = AB.NRORG
        							          AND PE.NRPESSOA = AB.NRPESSOA
        			JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                  								AND PEH.NRPESSOA       = PE.NRPESSOA
                  								AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                  														WHERE NRORG    = PEH.NRORG
                                  															AND NRPESSOA = PEH.NRPESSOA
                                  															AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
        			/*Pessoa Titular*/
        			JOIN GPE_VINCULOM VM ON VM.NRORG      = AB.NRORG
        								          AND VM.NRVINCULOM = AB.NRVINCULOM
        		  JOIN GPE_VINCULOH VH ON VH.NRORG          = VM.NRORG
                    							AND VH.NRVINCULOM     = VM.NRVINCULOM
                    							AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH GPE_VINCULOH1
                                  													 WHERE DTMESCOMPETENC <= CF.DTOCORRENCIA
                                  													 	 AND NRORG           = VM.NRORG
                                  														 AND NRVINCULOM      = VM.NRVINCULOM )							
        			JOIN GPE_PESSOA PET ON PET.NRORG    = VM.NRORG
        						    	       AND PET.NRPESSOA = VM.NRPESSOA
        			JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
                    							 AND PEHT.NRPESSOA       = PET.NRPESSOA
                    							 AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                  															WHERE NRORG    = PEHT.NRORG
                                  															  AND NRPESSOA = PEHT.NRPESSOA
                                  															  AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
        			LEFT JOIN RELACIONAPARC R ON R.NRORG          = PET.NRORG
                      								 AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                      								 AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
        			/*Benefício*/
        			JOIN VAB_BENEFICIARIO BF ON BF.NRORG            = AB.NRORG
                    									AND BF.NRBENEFICIOM     = AB.NRBENEFICIOM
                    									AND BF.NRVINCULOM       = AB.NRVINCULOM
                    									AND BF.NRPESSOA         = AB.NRPESSOA
        			JOIN VAB_BENEFICIOH BH ON BH.NRORG          = AB.NRORG
                    								AND BH.NRBENEFICIOM   = AB.NRBENEFICIOM
                    								AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                															 WHERE NRORG        = BH.NRORG
                                															   AND NRBENEFICIOM = BH.NRBENEFICIOM
                                															   AND DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/ )
        			/*Operadora do benefício Titular*/
        			LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BH.NRORG
                        							AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                        							AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                      														WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                      															AND DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                      															AND NRORG           = EHB.NRORG)
        			/**/
        		   WHERE CF.NRORG = :nrorg /*:P_NRORG*/
        		     AND CF.NRTIPOMOVIMENT = 21 /*Movimentos mensal*/
                 AND CF.NRTPMODALIDCAL = 1 /*Real*/
                 AND CF.NRTPMODALIDCAL = :nrcenario /*Cenário real apenas*/
        			 ".$queryPartPse."
        			 ".$queryPart."
        		   GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT, PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEH.NMPESSOA,
        			   BF.IDTPBENEFICIARIO, PEH.DTNASCPESSOA, PEH.NMPESSOA, AB.NRVINCULOM, CF.DTOCORRENCIA, AB.NRBENEFICIOM, R.NRTIPORELACIONA
  		  UNION ALL 
            SELECT
                EHB.CDCNPJESTRUT,
                TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
                EHB.CDFEDERALESTRUT,
                PEH.NRCPFPESSOA,
                LANC.NRCPFPESSOA NRCPFTITULAR,
                PEH.NMPESSOA,
                SUM(LANC.VREVENTOFOLHA) VALOR,
                DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
                DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
                DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
                R.NRTIPORELACIONA                                         NRTIPORELACIONA,
                SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', LANC.VREVENTOFOLHA, 0))  VALORDEP,
                COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY LANC.NRVINCULOM, LANC.DTOCORRENCIA, EHB.CDCNPJESTRUT) QTDEP,
                BF.IDTPBENEFICIARIO
              FROM LANCAMENTOSVINC_DIRF LANC
              /*Benefício*/
              JOIN VAB_BENEFICIARIO BF ON BF.NRORG      = LANC.NRORG
                                      AND BF.NRVINCULOM = LANC.NRVINCULOM
              JOIN VAB_BENEFICIOM BM ON BM.NRORG        = LANC.NRORG
                                    AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                    AND BM.IDATIVO      = 'S'
              JOIN VAB_BENEFICIOH BH ON BH.NRORG          = LANC.NRORG
                                    AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                    AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                              WHERE NRORG        = BH.NRORG
                                                                AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                                AND VAB_BENEFICIOH.DTMESCOMPETENC <= LANC.DTOCORRENCIACALC )
              /*Pessoa Titular*/
              JOIN GPE_PESSOA PET ON PET.NRORG    = LANC.NRORG
                                 AND PET.NRPESSOA = LANC.NRPESSOA
              /*Pessoa Dependente*/
              JOIN GPE_PESSOA PE ON PE.NRORG    = BF.NRORG
                                AND PE.NRPESSOA = BF.NRPESSOA
              JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                  AND PEH.NRPESSOA       = PE.NRPESSOA
                                  AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                             WHERE NRORG           = PEH.NRORG
                                                               AND NRPESSOA        = PEH.NRPESSOA
                                                               AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
              LEFT JOIN RELACIONAPARC R ON R.NRORG          = PET.NRORG
                                       AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                                       AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
              /*Operadora do benefício Titular*/
              LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BH.NRORG
                                      AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                      AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                 WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                   AND NRORG           = EHB.NRORG)
              WHERE LANC.NRORG = :nrorg /*:P_NRORG*/
                AND LANC.NRTIPOMOVIMENT = 1 /*Movimentos mensal*/
                AND LANC.DTOCORRENCIACALC >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                AND LANC.DTOCORRENCIACALC <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/))
                ".str_replace("CF.DTOCORRENCIA","LANC.DTOCORRENCIACALC",$queryPartPse)."
                AND LANC.NREVENTOM IN DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART, BH.NREVENTOCOPARTDEP) /*Parte co-participação      */
                AND EHB.CDFEDERALESTRUT IS NOT NULL
                AND LANC.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,LANC.DTOCORRENCIA)
              ".str_replace("VH.","LANC.",str_replace("VM.","LANC.",$queryPart))."
              GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT,
                PEH.NRCPFPESSOA, LANC.NRCPFPESSOA, PEH.NMPESSOA, BF.IDTPBENEFICIARIO,
                PEH.DTNASCPESSOA, R.NRTIPORELACIONA, LANC.NRVINCULOM, LANC.DTOCORRENCIA
      )
      WHERE VALOR > 0
)
GROUP BY CDCNPJESTRUT, NRCPFPESSOA, DTNASCPESSOADEP, PSE, OPSE, CNPJ_EMPR, NOME_EMPR, REG_ANS, TPSE, CDCPF, NOME, DTPSE, CDCPFDEP, DTNASCDEP, NOMEDEP, RELACDEP, NRCPFTITULAR, IDTPBENEFICIARIO
ORDER BY CNPJ_EMPR, NRCPFTITULAR, IDTPBENEFICIARIO DESC, CDCPFDEP
"
            );
        
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_pse($params,$queryPart,$queryPartPse){
        $sql = $this->entityManager->getConnection()->prepare("
/* get_pse */
SELECT
  CDCNPJESTRUT,
  NRCPFPESSOA,
  DTNASCPESSOADEP,
  PSE,
  OPSE,
  CNPJ_EMPR,
  NOME_EMPR,
  REG_ANS,
  TPSE,
  CDCPF,
  NOME,
  SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,
  DTPSE,
  CDCPFDEP,
  DTNASCDEP,
  NOMEDEP,
  RELACDEP,
  SUBSTR(ROUND(SUM(VALORDEP), 2) * 100, 1, 13) || '|' VALORDEP,
  NRCPFTITULAR
FROM (SELECT
      CDCNPJESTRUT,
      NRCPFPESSOA,
      DTNASCPESSOADEP,
      'PSE|' PSE,
      'OPSE|' OPSE,
      CDCNPJESTRUT || '|' CNPJ_EMPR,
      SUBSTR(REPLACE(REPLACE(REPLACE(NMRAZSOCESTRUT,'.'),'/'),'-'), 1, 150) || '|' NOME_EMPR,
      REPLACE(CDFEDERALESTRUT, '-', '') || '|' REG_ANS,
      'TPSE|' TPSE,
      LPAD(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
      SUBSTR(REPLACE(REPLACE(REPLACE(NMPESSOA,'.'),'/'),'-'), 1, 60) || '|' NOME,
      /*SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,*/ VALOR,
      'DTPSE|' DTPSE,
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOADEP,'.',''),'-',''), '0'), 11, '0') || '|' CDCPFDEP,
      LPAD(TO_CHAR(DTNASCPESSOADEP, 'YYYYMMDD'), 8, '0') || '|' DTNASCDEP,
      SUBSTR(REPLACE(REPLACE(REPLACE(NMPESSOADEP,'.'),'/'),'-'), 1, 60) || '|' NOMEDEP,
      LPAD(NVL(DECODE(NRTIPORELACIONA, 1, '08', /*Mae*/
                                       2, '08', /*Pai*/
                                       3, '04', /*Filho(a) ou enteado(a)*/
                                       4, '03', /*Conjuge*/
                                       7, '03', /*Companheiro(a) c/ o(a) qual...*/
                                       '10'), '0'), 2, '0') || '|' RELACDEP,
      VALORDEP / DECODE(QTDEP, 0, 1, QTDEP) VALORDEP,
      NRCPFTITULAR,
      IDTPBENEFICIARIO
    FROM (
          SELECT 
            EH1.CDCNPJESTRUT,
            TRANSLATE(EH1.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
            EH1.CDFEDERALESTRUT,
            PH1.NRCPFPESSOA,
            PH1.NRCPFPESSOA NRCPFTITULAR,
            PH1.NMPESSOA,
            SUM(ICF1.VREVENTOFOLHA) VALOR,
            '' NRCPFPESSOADEP,
            NULL DTNASCPESSOADEP,
            '' NMPESSOADEP,
            0 NRTIPORELACIONA,
            0 VALORDEP,
            0 QTDEP,
            'T' IDTPBENEFICIARIO
          FROM GPE_VINCULOM VM
          JOIN FPA_CALCULOFOLHA CF1 ON CF1.NRORG          = VM.NRORG  --Calculo
                                   AND CF1.NRTIPOMOVIMENT = 1 --Movimentos mensal
                                   AND CF1.NRTPMODALIDCAL = :nrcenario /*:P_CENARIO*/ --Cenário real apenas
                                   AND CF1.DTOCORRENCIA BETWEEN TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR') AND :dtcompetencia /*:P_COMPETENCIA*/
          JOIN DATA DT ON DT.DTDATA = CF1.DTOCORRENCIA
          JOIN GPE_VINCULOH VH ON VH.NRORG          = VM.NRORG
                              AND VH.NRVINCULOM     = VM.NRVINCULOM
                              AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH GPE_VINCULOH1
                                                        WHERE DTMESCOMPETENC <= DT.DTDATA /*CF1.DTOCORRENCIA*/
                                                          AND NRORG = VM.NRORG 
                                                          AND NRVINCULOM = VM.NRVINCULOM) 
          JOIN FPA_VINCEVENTO VEV1 ON (VEV1.NRORG = 0 OR VEV1.NRORG = VM.NRORG) --VincEvento de plano de saúde
                                  AND VEV1.NRVINCULOM = VM.NRVINCULOM
                                  AND VEV1.NRESTRUTURAM IS NOT NULL
                                  AND VEV1.DTINIVIGENCIA <= LAST_DAY(:dtcompetencia /*:P_COMPETENCIA*/)
                                  AND ( VEV1.DTFIMVIGENCIA >= TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR') OR VEV1.DTINIVIGENCIA <= LAST_DAY(:dtcompetencia /*:P_COMPETENCIA*/)
                                    AND VEV1.DTFIMVIGENCIA IS NULL )
          LEFT JOIN ESTRUTURAM EM1 ON EM1.NRORG        = VM.NRORG
                             AND EM1.NRESTRUTURAM = VEV1.NRESTRUTURAM
                             AND EM1.NRTIPOESTRUTURA IN (13,19) --PLANO DE SAUDE E PLANO ODONTOLOGICO
          LEFT JOIN ESTRUTURAH EH1 ON EH1.NRORG          = EM1.NRORG
                                  AND EH1.NRESTRUTURAM   = EM1.NRESTRUTURAM
                                  AND EH1.DTMESCOMPETENC = ( SELECT MAX(ESTRUTURAH1.DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH1
                                                             WHERE ESTRUTURAH1.NRESTRUTURAM = EH1.NRESTRUTURAM
                                                               AND ESTRUTURAH1.DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                                               AND ESTRUTURAH1.NRORG = EH1.NRORG)
          JOIN GPE_PESSOA PE1 ON PE1.NRORG    = VM.NRORG  --CPF e Nome do vínculo em questão (item 3.6)
                             AND PE1.NRPESSOA = VM.NRPESSOA
          JOIN GPE_PESSOAH PH1 ON PH1.NRORG    = VM.NRORG
                              AND PH1.NRPESSOA = PE1.NRPESSOA
                              AND PH1.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH GPE_PESSOAH1
                                                         WHERE DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                                           AND NRORG    = VM.NRORG
                                                           AND NRPESSOA = PE1.NRPESSOA )
          JOIN FPA_ITECALCFOLHA ICF1 ON ICF1.NRORG          = VM.NRORG
                                    AND ICF1.NRVINCULOM     = VM.NRVINCULOM
                                    AND ICF1.NREVENTOM      = VEV1.NREVENTOM
                                    AND ICF1.NRCALCULOFOLHA = CF1.NRCALCULOFOLHA
                                    AND ICF1.DTOCORRENCIA BETWEEN VEV1.DTINIVIGENCIA AND NVL(VEV1.DTFIMVIGENCIA, LAST_DAY( :dtcompetencia /*:P_COMPETENCIA*/ ))
          WHERE VM.NRORG = :nrorg /*:P_NRORG*/
            AND (VM.DTRESCISAOVINC <> VM.DTADMISSAOVINC OR VM.DTRESCISAOVINC IS NULL)
            AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR'))
            AND EH1.CDFEDERALESTRUT IS NOT NULL
            ".$queryPart."
            /*AND NOT EXISTS (SELECT 1
                             FROM VAB_BENEFICIARIO
                            WHERE NRORG = VM.NRORG
                              AND NRVINCULOM = VM.NRVINCULOM
                              AND NRVINCEVENTO = VEV1.NRVINCEVENTO)*/
            AND NOT EXISTS  ( SELECT 1
                              FROM VAB_APURABENEFICIO
                              WHERE NRORG = VM.NRORG
                                AND NRVINCULOM = VM.NRVINCULOM
                                AND NRCALCULOFOLHA = ( SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA AUX
                                                       WHERE AUX.NRORG = CF1.NRORG
                                                         AND AUX.DTOCORRENCIA = CF1.DTOCORRENCIA
                                                         AND AUX.NROCORRECAL = CF1.NROCORRECAL
                                                         AND AUX.NRTPMODALIDCAL = CF1.NRTPMODALIDCAL
                                                         AND ROWNUM <= 1 /*apenas por segurança*/
                                                         AND AUX.NRTIPOMOVIMENT = 21 ) )
          GROUP BY EH1.CDCNPJESTRUT, EH1.NMRAZSOCESTRUT, EH1.CDFEDERALESTRUT, PH1.NRCPFPESSOA, PH1.NMPESSOA, VM.NRVINCULOM
        UNION ALL 
          SELECT 
              EHB.CDCNPJESTRUT,
              TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
              EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA,
              PEHT.NRCPFPESSOA NRCPFTITULAR,
              PEH.NMPESSOA,
              SUM(ICF.VREVENTOFOLHA) VALOR,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
              R.NRTIPORELACIONA                                         NRTIPORELACIONA,
              SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', ICF.VREVENTOFOLHA, 0))  VALORDEP,
              COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY VM.NRVINCULOM, ICF.DTOCORRENCIA, EHB.CDCNPJESTRUT) QTDEP,
              BF.IDTPBENEFICIARIO
            FROM GPE_VINCULOM VM
            /*Benefício*/
            JOIN VAB_BENEFICIARIO BF ON BF.NRORG      = VM.NRORG
                                    AND BF.NRVINCULOM = VM.NRVINCULOM
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = VM.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            /*Cálculo*/
            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = :nrorg
                                    AND CF.NRTIPOMOVIMENT = 1 /*Movimentos mensal*/
                                    AND CF.NRTPMODALIDCAL = :nrcenario /*:P_CENARIO*/ --Cenário real apenas
                                    $queryPartPse
                                    AND CF.DTOCORRENCIA >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                                    AND CF.DTOCORRENCIA <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/))
            JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = VM.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= DT.DTDATA )
            /*Itens de cálculo*/
            JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                     AND ICF.NRVINCULOM     = VM.NRVINCULOM
                                     AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                     AND ICF.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULARVINC, BH.NREVEDEPEVINC    ),  /*Parte do vínculo/dependente*/
                                                            DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP) ) /*Parte co-participação      */
            /*Vínculo*/
            JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                AND VH.NRVINCULOM = VM.NRVINCULOM
                                AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                          WHERE DTMESCOMPETENC <= DT.DTDATA
                                                            AND NRORG           = VM.NRORG
                                                            AND NRVINCULOM      = VM.NRVINCULOM )
            /*Pessoa Titular*/
            JOIN GPE_PESSOA PET ON PET.NRORG    = VM.NRORG
                               AND PET.NRPESSOA = VM.NRPESSOA
            JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
                                 AND PEHT.NRPESSOA       = PET.NRPESSOA
                                 AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                             WHERE NRORG           = PEHT.NRORG
                                                               AND NRPESSOA        = PEHT.NRPESSOA
                                                               AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            /*Pessoa Dependente*/
            JOIN GPE_PESSOA PE ON PE.NRORG    = VM.NRORG
                              AND PE.NRPESSOA = BF.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                AND PEH.NRPESSOA       = PE.NRPESSOA
                                AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                           WHERE NRORG           = PEH.NRORG
                                                             AND NRPESSOA        = PEH.NRPESSOA
                                                             AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            LEFT JOIN RELACIONAPARC R ON R.NRORG          = VM.NRORG
                                     AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                                     AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE VM.NRORG = :nrorg /*:P_NRORG*/
            AND EHB.CDFEDERALESTRUT IS NOT NULL
            AND ICF.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,ICF.DTOCORRENCIA)
            ".$queryPart."
            GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEH.NMPESSOA, BF.IDTPBENEFICIARIO,
              PEH.DTNASCPESSOA, R.NRTIPORELACIONA, VM.NRVINCULOM, ICF.DTOCORRENCIA
    )
    WHERE VALOR > 0
)
GROUP BY CDCNPJESTRUT, NRCPFPESSOA, DTNASCPESSOADEP, PSE, OPSE, CNPJ_EMPR, NOME_EMPR, REG_ANS, TPSE, CDCPF, NOME, DTPSE, CDCPFDEP, DTNASCDEP, NOMEDEP, RELACDEP, NRCPFTITULAR, IDTPBENEFICIARIO
ORDER BY CNPJ_EMPR, NRCPFTITULAR, IDTPBENEFICIARIO DESC, CDCPFDEP"
            );
            
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_pse_new($params,$queryPart,$queryPartPse){
        $sql = $this->entityManager->getConnection()->prepare("
/* get_pse_new */
SELECT
  CDCNPJESTRUT,
  NRCPFPESSOA,
  DTNASCPESSOADEP,
  PSE,
  OPSE,
  CNPJ_EMPR,
  NOME_EMPR,
  REG_ANS,
  TPSE,
  CDCPF,
  NOME,
  SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,
  DTPSE,
  CDCPFDEP,
  DTNASCDEP,
  NOMEDEP,
  RELACDEP,
  SUBSTR(ROUND(SUM(VALORDEP), 2) * 100, 1, 13) || '|' VALORDEP,
  NRCPFTITULAR
FROM (SELECT
      CDCNPJESTRUT,
      NRCPFPESSOA,
      DTNASCPESSOADEP,
      'PSE|' PSE,
      'OPSE|' OPSE,
      CDCNPJESTRUT || '|' CNPJ_EMPR,
      SUBSTR(NMRAZSOCESTRUT, 1, 150) || '|' NOME_EMPR,
      REPLACE(CDFEDERALESTRUT, '-', '') || '|' REG_ANS,
      'TPSE|' TPSE,
      LPAD(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
      SUBSTR(NMPESSOA, 1, 60) || '|' NOME,
      /*SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,*/ VALOR,
      'DTPSE|' DTPSE,
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOADEP,'.',''),'-',''), '0'), 11, '0') || '|' CDCPFDEP,
      LPAD(TO_CHAR(DTNASCPESSOADEP, 'YYYYMMDD'), 8, '0') || '|' DTNASCDEP,
      SUBSTR(NMPESSOADEP, 1, 60) || '|' NOMEDEP,
      LPAD(NVL(DECODE(NRTIPORELACIONA, 1, '08', /*Mae*/
                                       2, '08', /*Pai*/
                                       3, '04', /*Filho(a) ou enteado(a)*/
                                       4, '03', /*Conjuge*/
                                       7, '03', /*Companheiro(a) c/ o(a) qual...*/
                                       '10'), '0'), 2, '0') || '|' RELACDEP,
      VALORDEP / DECODE(QTDEP, 0, 1, QTDEP) VALORDEP,
      NRCPFTITULAR,
      IDTPBENEFICIARIO
    FROM (
          SELECT 
            EH1.CDCNPJESTRUT,
            TRANSLATE(EH1.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
            EH1.CDFEDERALESTRUT,
            PH1.NRCPFPESSOA,
            PH1.NRCPFPESSOA NRCPFTITULAR,
            PH1.NMPESSOA,
            SUM(LANC.VREVENTOFOLHA) VALOR,
            SUM(LANC.VREVENTOFOLHA) VALORTOTAL,
            '' NRCPFPESSOADEP,
            NULL DTNASCPESSOADEP,
            '' NMPESSOADEP,
            0 NRTIPORELACIONA,
            0 VALORDEP,
            0 QTDEP,
            'T' IDTPBENEFICIARIO
          FROM LANCAMENTOSVINC_TMP LANC
          JOIN FPA_VINCEVENTO VEV1 ON (VEV1.NRORG = 0 OR VEV1.NRORG = LANC.NRORG) --VincEvento de plano de saúde
                                  AND VEV1.NRVINCULOM = LANC.NRVINCULOM
                                  AND VEV1.NRESTRUTURAM IS NOT NULL
                                  AND VEV1.DTINIVIGENCIA <= LAST_DAY(:dtcompetencia /*:P_COMPETENCIA*/)
                                  AND ( VEV1.DTFIMVIGENCIA >= TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR') OR VEV1.DTINIVIGENCIA <= LAST_DAY(:dtcompetencia /*:P_COMPETENCIA*/)
                                    AND VEV1.DTFIMVIGENCIA IS NULL )
                                  AND VEV1.NREVENTOM = LANC.NREVENTOM
          LEFT JOIN ESTRUTURAM EM1 ON EM1.NRORG        = LANC.NRORG
                             AND EM1.NRESTRUTURAM = VEV1.NRESTRUTURAM
                             AND EM1.NRTIPOESTRUTURA IN (13,19) --PLANO DE SAUDE E PLANO ODONTOLOGICO
          LEFT JOIN ESTRUTURAH EH1 ON EH1.NRORG          = EM1.NRORG
                                  AND EH1.NRESTRUTURAM   = EM1.NRESTRUTURAM
                                  AND EH1.DTMESCOMPETENC = ( SELECT MAX(ESTRUTURAH1.DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH1
                                                             WHERE ESTRUTURAH1.NRESTRUTURAM = EH1.NRESTRUTURAM
                                                               AND ESTRUTURAH1.DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                                               AND ESTRUTURAH1.NRORG = EH1.NRORG)
          JOIN GPE_PESSOA PE1 ON PE1.NRORG    = LANC.NRORG  --CPF e Nome do vínculo em questão (item 3.6)
                             AND PE1.NRPESSOA = LANC.NRPESSOA
          JOIN GPE_PESSOAH PH1 ON PH1.NRORG    = LANC.NRORG
                              AND PH1.NRPESSOA = PE1.NRPESSOA
                              AND PH1.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH GPE_PESSOAH1
                                                         WHERE DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                                           AND NRORG    = LANC.NRORG
                                                           AND NRPESSOA = PE1.NRPESSOA )
          WHERE LANC.NRORG = :nrorg /*:P_NRORG*/
            AND (LANC.DTRESCISAOVINC <> LANC.DTADMISSAOVINC OR LANC.DTRESCISAOVINC IS NULL)
            AND (LANC.DTRESCISAOVINC IS NULL OR LANC.DTRESCISAOVINC >= TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR'))
            AND LANC.NRTIPOMOVIMENT = 1 --Movimentos mensal
            AND LANC.DTOCORRENCIACALC BETWEEN TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR') AND :dtcompetencia /*:P_COMPETENCIA*/
            AND LANC.DTOCORRENCIA BETWEEN VEV1.DTINIVIGENCIA AND NVL(VEV1.DTFIMVIGENCIA, LAST_DAY( :dtcompetencia /*:P_COMPETENCIA*/ ))
            AND EH1.CDFEDERALESTRUT IS NOT NULL
            ".$queryPart."
            /*AND NOT EXISTS (SELECT 1
                             FROM VAB_BENEFICIARIO
                            WHERE NRORG = LANC.NRORG
                              AND NRVINCULOM = LANC.NRVINCULOM
                              AND NRVINCEVENTO = VEV1.NRVINCEVENTO)*/
            AND NOT EXISTS  ( SELECT 1
                              FROM VAB_APURABENEFICIO
                              WHERE NRORG = LANC.NRORG
                                AND NRVINCULOM = LANC.NRVINCULOM
                                AND NRCALCULOFOLHA = ( SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA AUX
                                                       WHERE AUX.NRORG = LANC.NRORG
                                                         AND AUX.DTOCORRENCIA = LANC.DTOCORRENCIACALC
                                                         AND AUX.NROCORRECAL = LANC.NROCORRECAL
                                                         AND AUX.NRTPMODALIDCAL = LANC.NRTPMODALIDCAL
                                                         AND ROWNUM <= 1 /*apenas por segurança*/
                                                         AND AUX.NRTIPOMOVIMENT = 21 ) )
          GROUP BY EH1.CDCNPJESTRUT, EH1.NMRAZSOCESTRUT, EH1.CDFEDERALESTRUT, PH1.NRCPFPESSOA, PH1.NMPESSOA, LANC.NRVINCULOM
        UNION ALL 
          SELECT
              EHB.CDCNPJESTRUT,
              TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
              EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA,
              PEHT.NRCPFPESSOA NRCPFTITULAR,
              PEH.NMPESSOA,
              --SUM(LANC.VREVENTOFOLHA) VALOR,
              SUM(CASE WHEN LANC.NREVENTOM IN (BH.NREVETITULARVINC, BH.NREVENTOCOPART, BH.NREVEDEPEVINC, BH.NREVENTOCOPARTDEP) THEN LANC.VREVENTOFOLHA ELSE 0 END) VALOR,
              SUM(LANC.VREVENTOFOLHA) VALORTOTAL,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
              R.NRTIPORELACIONA                                         NRTIPORELACIONA,
              --SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', LANC.VREVENTOFOLHA, 0))  VALORDEP,
              SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', CASE WHEN LANC.NREVENTOM IN (BH.NREVEDEPEVINC, BH.NREVENTOCOPARTDEP) THEN LANC.VREVENTOFOLHA ELSE 0 END, 0))  VALORDEP,
              COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY LANC.NRVINCULOM, LANC.DTOCORRENCIA, EHB.CDCNPJESTRUT) QTDEP,
              BF.IDTPBENEFICIARIO
            FROM LANCAMENTOSVINC_TMP LANC
            /*Benefício*/
            JOIN VAB_BENEFICIARIO BF ON BF.NRORG      = LANC.NRORG
                                    AND BF.NRVINCULOM = LANC.NRVINCULOM
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = LANC.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = LANC.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= LANC.DTOCORRENCIACALC )
            /*Pessoa Titular*/
            JOIN GPE_PESSOA PET ON PET.NRORG    = LANC.NRORG
                               AND PET.NRPESSOA = LANC.NRPESSOA
            JOIN GPE_PESSOAH PEHT ON PEHT.NRORG          = PET.NRORG
                                 AND PEHT.NRPESSOA       = PET.NRPESSOA
                                 AND PEHT.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                             WHERE NRORG           = PEHT.NRORG
                                                               AND NRPESSOA        = PEHT.NRPESSOA
                                                               AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            /*Pessoa Dependente*/
            JOIN GPE_PESSOA PE ON PE.NRORG    = LANC.NRORG
                              AND PE.NRPESSOA = BF.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                AND PEH.NRPESSOA       = PE.NRPESSOA
                                AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                           WHERE NRORG           = PEH.NRORG
                                                             AND NRPESSOA        = PEH.NRPESSOA
                                                             AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            LEFT JOIN RELACIONAPARC R ON R.NRORG          = LANC.NRORG
                                     AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                                     AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE LANC.NRORG = :nrorg /*:P_NRORG*/
            AND LANC.NRTIPOMOVIMENT = 1 /*Movimentos mensal*/
            AND LANC.DTOCORRENCIACALC >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
            AND LANC.DTOCORRENCIACALC <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/))
            $queryPartPse
            AND LANC.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULARVINC, BH.NREVEDEPEVINC    ),  /*Parte do vínculo/dependente*/
                                   DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP),   /*Parte co-participação      */
                                   DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULAREMP,  BH.NREVEDEPEMPRESA) )    /*Parte parte empresa      */
            AND EHB.CDFEDERALESTRUT IS NOT NULL
            AND LANC.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,LANC.DTOCORRENCIA)
            ".$queryPart."
            GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA, PEHT.NRCPFPESSOA, PEH.NMPESSOA, BF.IDTPBENEFICIARIO,
              PEH.DTNASCPESSOA, R.NRTIPORELACIONA, LANC.NRVINCULOM, LANC.DTOCORRENCIA
    )
    WHERE VALORTOTAL > 0
)
GROUP BY CDCNPJESTRUT, NRCPFPESSOA, DTNASCPESSOADEP, PSE, OPSE, CNPJ_EMPR, NOME_EMPR, REG_ANS, TPSE, CDCPF, NOME, DTPSE, CDCPFDEP, DTNASCDEP, NOMEDEP, RELACDEP, NRCPFTITULAR, IDTPBENEFICIARIO
ORDER BY CNPJ_EMPR, NRCPFTITULAR, IDTPBENEFICIARIO DESC, CDCPFDEP"
            );
            
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_pse_hcm($params,$queryPart,$queryPartPse){
        $sql = $this->entityManager->getConnection()->prepare("
/* get_pse_hcm */
SELECT
  CDCNPJESTRUT,
  NRCPFPESSOA,
  DTNASCPESSOADEP,
  PSE,
  OPSE,
  CNPJ_EMPR,
  NOME_EMPR,
  REG_ANS,
  TPSE,
  CDCPF,
  NOME,
  SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,
  DTPSE,
  CDCPFDEP,
  DTNASCDEP,
  NOMEDEP,
  RELACDEP,
  SUBSTR(ROUND(SUM(VALORDEP), 2) * 100, 1, 13) || '|' VALORDEP,
  NRCPFTITULAR
FROM (SELECT
      CDCNPJESTRUT,
      NRCPFPESSOA,
      DTNASCPESSOADEP,
      'PSE|' PSE,
      'OPSE|' OPSE,
      CDCNPJESTRUT || '|' CNPJ_EMPR,
      SUBSTR(NMRAZSOCESTRUT, 1, 150) || '|' NOME_EMPR,
      REPLACE(CDFEDERALESTRUT, '-', '') || '|' REG_ANS,
      'TPSE|' TPSE,
      LPAD(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
      SUBSTR(NMPESSOA, 1, 60) || '|' NOME,
      /*SUBSTR(ROUND(SUM(VALOR), 2) * 100, 1, 13) || '|' VALOR,*/ VALOR,
      'DTPSE|' DTPSE,
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOADEP,'.',''),'-',''), '0'), 11, '0') || '|' CDCPFDEP,
      LPAD(TO_CHAR(DTNASCPESSOADEP, 'YYYYMMDD'), 8, '0') || '|' DTNASCDEP,
      SUBSTR(NMPESSOADEP, 1, 60) || '|' NOMEDEP,
      LPAD(NVL(DECODE(NRTIPORELACIONA, 1, '08', /*Mae*/
                                       2, '08', /*Pai*/
                                       3, '04', /*Filho(a) ou enteado(a)*/
                                       4, '03', /*Conjuge*/
                                       7, '03', /*Companheiro(a) c/ o(a) qual...*/
                                       '10'), '0'), 2, '0') || '|' RELACDEP,
      VALORDEP / DECODE(QTDEP, 0, 1, QTDEP) VALORDEP,
      NRCPFTITULAR,
      IDTPBENEFICIARIO
    FROM (
          SELECT 
            EH1.CDCNPJESTRUT,
            TRANSLATE(EH1.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
            EH1.CDFEDERALESTRUT,
            LANC.NRCPFPESSOA,
            LANC.NRCPFPESSOA NRCPFTITULAR,
            LANC.NMPESSOA,
            SUM(LANC.VREVENTOFOLHA) VALOR,
            SUM(LANC.VREVENTOFOLHA) VALORTOTAL,
            '' NRCPFPESSOADEP,
            NULL DTNASCPESSOADEP,
            '' NMPESSOADEP,
            0 NRTIPORELACIONA,
            0 VALORDEP,
            0 QTDEP,
            'T' IDTPBENEFICIARIO
          FROM LANCAMENTOSVINC_DIRF LANC
          JOIN FPA_VINCEVENTO VEV1 ON (VEV1.NRORG = 0 OR VEV1.NRORG = LANC.NRORG) --VincEvento de plano de saúde
                                  AND VEV1.NRVINCULOM = LANC.NRVINCULOM
                                  AND VEV1.NRESTRUTURAM IS NOT NULL
                                  AND VEV1.DTINIVIGENCIA <= LAST_DAY(:dtcompetencia /*:P_COMPETENCIA*/)
                                  AND ( VEV1.DTFIMVIGENCIA >= TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR') OR VEV1.DTINIVIGENCIA <= LAST_DAY(:dtcompetencia /*:P_COMPETENCIA*/)
                                    AND VEV1.DTFIMVIGENCIA IS NULL )
                                  AND VEV1.NREVENTOM = LANC.NREVENTOM
          LEFT JOIN ESTRUTURAM EM1 ON EM1.NRORG        = LANC.NRORG
                             AND EM1.NRESTRUTURAM = VEV1.NRESTRUTURAM
                             AND EM1.NRTIPOESTRUTURA IN (13,19) --PLANO DE SAUDE E PLANO ODONTOLOGICO
          LEFT JOIN ESTRUTURAH EH1 ON EH1.NRORG          = EM1.NRORG
                                  AND EH1.NRESTRUTURAM   = EM1.NRESTRUTURAM
                                  AND EH1.DTMESCOMPETENC = ( SELECT MAX(ESTRUTURAH1.DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH1
                                                             WHERE ESTRUTURAH1.NRESTRUTURAM = EH1.NRESTRUTURAM
                                                               AND ESTRUTURAH1.DTMESCOMPETENC <= :dtcompetencia /*:P_COMPETENCIA*/
                                                               AND ESTRUTURAH1.NRORG = EH1.NRORG)
          WHERE LANC.NRORG = :nrorg /*:P_NRORG*/
            AND (LANC.DTRESCISAOVINC <> LANC.DTADMISSAOVINC OR LANC.DTRESCISAOVINC IS NULL)
            AND (LANC.DTRESCISAOVINC IS NULL OR LANC.DTRESCISAOVINC >= TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR'))
            AND LANC.NRTIPOMOVIMENT = 1 --Movimentos mensal
            AND LANC.DTOCORRENCIACALC BETWEEN TRUNC(TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 'YEAR') AND :dtcompetencia /*:P_COMPETENCIA*/
            AND LANC.DTOCORRENCIA BETWEEN VEV1.DTINIVIGENCIA AND NVL(VEV1.DTFIMVIGENCIA, LAST_DAY( :dtcompetencia /*:P_COMPETENCIA*/ ))
            AND EH1.CDFEDERALESTRUT IS NOT NULL
            ".$queryPart."
            /*AND NOT EXISTS (SELECT 1
                             FROM VAB_BENEFICIARIO
                            WHERE NRORG = LANC.NRORG
                              AND NRVINCULOM = LANC.NRVINCULOM
                              AND NRVINCEVENTO = VEV1.NRVINCEVENTO)*/
            AND NOT EXISTS  ( SELECT 1
                              FROM VAB_APURABENEFICIO
                              WHERE NRORG = LANC.NRORG
                                AND NRVINCULOM = LANC.NRVINCULOM
                                AND NRCALCULOFOLHA = ( SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA AUX
                                                       WHERE AUX.NRORG = LANC.NRORG
                                                         AND AUX.DTOCORRENCIA = LANC.DTOCORRENCIACALC
                                                         AND AUX.NROCORRECAL = LANC.NROCORRECAL
                                                         AND AUX.NRTPMODALIDCAL = LANC.NRTPMODALIDCAL
                                                         AND ROWNUM <= 1 /*apenas por segurança*/
                                                         AND AUX.NRTIPOMOVIMENT = 21 ) )
          GROUP BY EH1.CDCNPJESTRUT, EH1.NMRAZSOCESTRUT, EH1.CDFEDERALESTRUT, LANC.NRCPFPESSOA, LANC.NMPESSOA, LANC.NRVINCULOM
        UNION ALL 
          SELECT
              EHB.CDCNPJESTRUT,
              TRANSLATE(EHB.NMRAZSOCESTRUT,'ÁÇÉÍÓÚÀÈÌÒÙÂÊÎÔÛÃÕËÜáçéíóúàèìòùâêîôûãõëü','ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu') NMRAZSOCESTRUT,
              EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA,
              LANC.NRCPFPESSOA NRCPFTITULAR,
              PEH.NMPESSOA,
              --SUM(LANC.VREVENTOFOLHA) VALOR,
              SUM(CASE WHEN LANC.NREVENTOM IN (BH.NREVETITULARVINC, BH.NREVENTOCOPART, BH.NREVEDEPEVINC, BH.NREVENTOCOPARTDEP) THEN LANC.VREVENTOFOLHA ELSE 0 END) VALOR,
              SUM(LANC.VREVENTOFOLHA) VALORTOTAL,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NRCPFPESSOA,    '')  NRCPFPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.DTNASCPESSOA, NULL)  DTNASCPESSOADEP,
              DECODE(BF.IDTPBENEFICIARIO, 'D', PEH.NMPESSOA,       '')  NMPESSOADEP,
              R.NRTIPORELACIONA                                         NRTIPORELACIONA,
              --SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', LANC.VREVENTOFOLHA, 0))  VALORDEP,
              SUM(DECODE(BF.IDTPBENEFICIARIO, 'D', CASE WHEN LANC.NREVENTOM IN (BH.NREVEDEPEVINC, BH.NREVENTOCOPARTDEP) THEN LANC.VREVENTOFOLHA ELSE 0 END, 0))  VALORDEP,
              COUNT(CASE WHEN BF.IDTPBENEFICIARIO = 'D' THEN 1 END) OVER (PARTITION BY LANC.NRVINCULOM, LANC.DTOCORRENCIA, EHB.CDCNPJESTRUT) QTDEP,
              BF.IDTPBENEFICIARIO
            FROM LANCAMENTOSVINC_DIRF LANC
            /*Benefício*/
            JOIN VAB_BENEFICIARIO BF ON BF.NRORG      = LANC.NRORG
                                    AND BF.NRVINCULOM = LANC.NRVINCULOM
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = LANC.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = LANC.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= LANC.DTOCORRENCIACALC )
            /*Pessoa Titular*/
            JOIN GPE_PESSOA PET ON PET.NRORG    = LANC.NRORG
                               AND PET.NRPESSOA = LANC.NRPESSOA
            /*Pessoa Dependente*/
            JOIN GPE_PESSOA PE ON PE.NRORG    = LANC.NRORG
                              AND PE.NRPESSOA = BF.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                AND PEH.NRPESSOA       = PE.NRPESSOA
                                AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                           WHERE NRORG           = PEH.NRORG
                                                             AND NRPESSOA        = PEH.NRPESSOA
                                                             AND DTMESCOMPETENC <= TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/) )
            LEFT JOIN RELACIONAPARC R ON R.NRORG          = LANC.NRORG
                                     AND R.NRPARCNEGOCIO  = PET.NRPARCNEGOCIO
                                     AND R.NRPARCNEGRELAC = PE.NRPARCNEGOCIO
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE LANC.NRORG = :nrorg /*:P_NRORG*/
            AND LANC.NRTIPOMOVIMENT = 1 /*Movimentos mensal*/
            AND LANC.DTOCORRENCIACALC >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
            AND LANC.DTOCORRENCIACALC <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :dtcompetencia /*:P_COMPETENCIA*/))
            $queryPartPse
            AND LANC.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULARVINC, BH.NREVEDEPEVINC    ),  /*Parte do vínculo/dependente*/
                                   DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP),   /*Parte co-participação      */
                                   DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULAREMP,  BH.NREVEDEPEMPRESA) )    /*Parte parte empresa      */
            AND EHB.CDFEDERALESTRUT IS NOT NULL
            AND LANC.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,LANC.DTOCORRENCIA)
            ".$queryPart."
            GROUP BY EHB.CDCNPJESTRUT, EHB.NMRAZSOCESTRUT, EHB.CDFEDERALESTRUT,
              PEH.NRCPFPESSOA, LANC.NRCPFPESSOA, PEH.NMPESSOA, BF.IDTPBENEFICIARIO,
              PEH.DTNASCPESSOA, R.NRTIPORELACIONA, LANC.NRVINCULOM, LANC.DTOCORRENCIA
    )
    WHERE VALORTOTAL > 0
)
GROUP BY CDCNPJESTRUT, NRCPFPESSOA, DTNASCPESSOADEP, PSE, OPSE, CNPJ_EMPR, NOME_EMPR, REG_ANS, TPSE, CDCPF, NOME, DTPSE, CDCPFDEP, DTNASCDEP, NOMEDEP, RELACDEP, NRCPFTITULAR, IDTPBENEFICIARIO
ORDER BY CNPJ_EMPR, NRCPFTITULAR, IDTPBENEFICIARIO DESC, CDCPFDEP"
            );
            
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_motor_inf($params,$queryPart){
        $sql = $this->entityManager->getConnection()->prepare(
        "SELECT 
  VM.NMVINCULOM,
  PH1.NRCPFPESSOA,
  'INF|'                               INF,
  LPAD(REPLACE(REPLACE(PH1.NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
  'TOTAL DE DESPESAS MEDICOODONTOHOSPITALARES: '
    || LTRIM(TO_CHAR(SUM(ICF.VREVENTOFOLHA), '99999999999.99')) COMPLEMENTO
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
--CPF e Nome do vínculo em questão (item 3.6)
JOIN GPE_PESSOAH PH1 ON PH1.NRORG    = VM.NRORG
                   AND PH1.NRPESSOA = VM.NRPESSOA
                   AND PH1.DTMESCOMPETENC = ANY ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                              WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                AND NRORG    = VM.NRORG
                                                AND NRPESSOA = VM.NRPESSOA
                                            INTERSECT
                                              SELECT PH2.DTMESCOMPETENC
                                              FROM GPE_PESSOAH PH2
                                              WHERE PH2.NRPESSOA = VM.NRPESSOA
                                              AND PH2.NRORG      = VM.NRORG )
--Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo
JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = VM.NRORG OR GIN.NRORG = 0 )
                         AND GIN.NRGRPINCIDE = :nrgrupoinciden
JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = VM.NRORG OR GIT.NRORG = 0 )
                         AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                         AND GIT.NRITEM = 99 /*Apenas 'informações complementares'*/
JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = VM.NRORG OR IEV.NRORG = 0 )
                         AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
JOIN FPA_CALCULOFOLHA  CF ON CF.NRORG          = VM.NRORG
                         AND CF.NRTIPOMOVIMENT = 1 
                         AND CF.NRTPMODALIDCAL = :nrcenario
                         AND CF.DTOCORRENCIA BETWEEN TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) AND :dtcompetencia 
JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = VM.NRORG
                         AND ICF.NRVINCULOM     = VM.NRVINCULOM
                         AND ICF.NREVENTOM      = IEV.NREVENTOM
                         AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
WHERE VM.NRORG = :nrorg 
  AND ( VM.DTRESCISAOVINC <> VM.DTADMISSAOVINC OR VM.DTRESCISAOVINC IS NULL )
  AND ( VM.DTRESCISAOVINC IS NULL OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
  ".$queryPart."
  AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                            WHERE DTMESCOMPETENC <= DT.DTDATA /*CF.DTOCORRENCIA*/
                              AND NRORG      = VM.NRORG
                              AND NRVINCULOM = VM.NRVINCULOM )
  AND ICF.VREVENTOFOLHA > 0
GROUP BY VM.NMVINCULOM, PH1.NRCPFPESSOA/*, DECODE(VEV.NREVENTOM,NULL,'OUTRAS DESPESAS MEDICOODONTOHOSPITALARES: ','DESPESAS MEDICOODONTOHOSPITALARES: ')*/
ORDER BY 2, 4
"
            );
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_motor_inf_new($params,$queryPart,$queryPartInf){
        $sql = $this->entityManager->getConnection()->prepare(
"SELECT
  LANC.NMVINCULOM,
  PH1.NRCPFPESSOA,
  'INF|'                               INF,
  LPAD(REPLACE(REPLACE(PH1.NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
  'TOTAL DE DESPESAS MEDICOODONTOHOSPITALARES: '
    || LTRIM(TO_CHAR(SUM(LANC.VREVENTOFOLHA), '99999999999.99')) COMPLEMENTO
FROM LANCAMENTOSVINC_TMP LANC
--CPF e Nome do vínculo em questão (item 3.6)
JOIN GPE_PESSOAH PH1 ON PH1.NRORG    = LANC.NRORG
                   AND PH1.NRPESSOA = LANC.NRPESSOA
                   AND PH1.DTMESCOMPETENC = ANY ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                              WHERE DTMESCOMPETENC <= :dtcompetencia 
                                                AND NRORG    = LANC.NRORG
                                                AND NRPESSOA = LANC.NRPESSOA
                                            INTERSECT
                                              SELECT PH2.DTMESCOMPETENC
                                              FROM GPE_PESSOAH PH2
                                              WHERE PH2.NRPESSOA = LANC.NRPESSOA
                                              AND PH2.NRORG      = LANC.NRORG )
--Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo
JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = LANC.NRORG OR GIN.NRORG = 0 )
                         AND GIN.NRGRPINCIDE = :nrgrupoinciden
JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                         AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                         AND GIT.NRITEM = 99 /*Apenas 'informações complementares'*/
JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                         AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                         AND IEV.NREVENTOM    = LANC.NREVENTOM
WHERE LANC.NRORG = :nrorg 
  AND ( LANC.DTRESCISAOVINC <> LANC.DTADMISSAOVINC OR LANC.DTRESCISAOVINC IS NULL )
  AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
  AND LANC.NRTIPOMOVIMENT = 1
  --AND LANC.DTOCORRENCIACALC BETWEEN TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) AND :dtcompetencia
  ".$queryPartInf."
  ".$queryPart."
  AND LANC.VREVENTOFOLHA > 0
GROUP BY LANC.NMVINCULOM, PH1.NRCPFPESSOA/*, DECODE(VEV.NREVENTOM,NULL,'OUTRAS DESPESAS MEDICOODONTOHOSPITALARES: ','DESPESAS MEDICOODONTOHOSPITALARES: ')*/
ORDER BY 2, 4
"
            );
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_motor_inf_hcm($params,$queryPart,$queryPartInf){
        $sql = $this->entityManager->getConnection()->prepare(
"/* get_motor_inf_hcm */
SELECT
  LANC.NMVINCULOM,
  LANC.NRCPFPESSOA,
  'INF|'                               INF,
  LPAD(REPLACE(REPLACE(LANC.NRCPFPESSOA,'.',''),'-',''), 11, '0') || '|' CDCPF,
  'TOTAL DE DESPESAS MEDICOODONTOHOSPITALARES: '
    || LTRIM(TO_CHAR(SUM(LANC.VREVENTOFOLHA), '99999999999.99')) COMPLEMENTO
FROM LANCAMENTOSVINC_DIRF LANC
--Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo
JOIN FPA_GRPINCIDE    GIN ON ( GIN.NRORG = LANC.NRORG OR GIN.NRORG = 0 )
                         AND GIN.NRGRPINCIDE = :nrgrupoinciden
JOIN FPA_GRPITEM      GIT ON ( GIT.NRORG = LANC.NRORG OR GIT.NRORG = 0 )
                         AND GIT.NRGRPINCIDE = GIN.NRGRPINCIDE
                         AND GIT.NRITEM = 99 /*Apenas 'informações complementares'*/
JOIN FPA_INCIDEVENTO  IEV ON ( IEV.NRORG = LANC.NRORG OR IEV.NRORG = 0 )
                         AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
                         AND IEV.NREVENTOM    = LANC.NREVENTOM
WHERE LANC.NRORG = :nrorg 
  AND ( LANC.DTRESCISAOVINC <> LANC.DTADMISSAOVINC OR LANC.DTRESCISAOVINC IS NULL )
  AND ( LANC.DTRESCISAOVINC IS NULL OR ( LANC.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia  ), 'YEAR' ) ) )
  AND LANC.NRTIPOMOVIMENT = 1
  --AND LANC.DTOCORRENCIACALC BETWEEN TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) AND :dtcompetencia
  ".$queryPartInf."
  ".$queryPart."
  AND LANC.VREVENTOFOLHA > 0
GROUP BY LANC.NMVINCULOM, LANC.NRCPFPESSOA/*, DECODE(VEV.NREVENTOM,NULL,'OUTRAS DESPESAS MEDICOODONTOHOSPITALARES: ','DESPESAS MEDICOODONTOHOSPITALARES: ')*/
ORDER BY 2, 4
"
            );
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function get_nrvinculos($params, $queryPart){
        $sql = $this->entityManager->getConnection()->prepare(
        "SELECT
  VM.NRVINCULOM
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
WHERE VM.NRORG = :nrorg 
  ".$queryPart."
  AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                            WHERE DTMESCOMPETENC <=  :dtcompetencia
                              AND NRORG         = VM.NRORG
                              AND NRVINCULOM    = VM.NRVINCULOM
                              AND NRESTRUTLEGAL = VH.NRESTRUTLEGAL )
"
            );
        $sql->execute($params);
        return $sql->fetchAll();
    }
    
    public function getVinculosDirf($params, $queryPart){
        $sql = $this->entityManager->getConnection()->prepare(
        "/* getVinculosDirf */
SELECT VM.NRORG, VM.NRVINCULOM, VM.NRPESSOA, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, VM.NRTIPOVINCULOM, VM.NRVINCULOEMPREG, VM.NMVINCULOM,
	   VH.DTMESCOMPETENC, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN, VH.NRESTRUTSIND
	FROM GPE_VINCULOM VM 
	JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM (SELECT H1.DTMESCOMPETENC FROM GPE_VINCULOH H1
                                                                                 WHERE H1.NRORG      = VH.NRORG
                                                                                   AND H1.NRVINCULOM = VH.NRVINCULOM
                                                                                   AND H1.DTMESCOMPETENC BETWEEN ADD_MONTHS(TRUNC(TO_DATE(:dtcompetencia),'YEAR'),-1) AND TO_DATE(:dtcompetencia)
                                                                                 ORDER BY H1.DTMESCOMPETENC DESC) WHERE ROWNUM = 1)
 WHERE VM.NRORG = :nrorg
   ".$queryPart
            );
        $sql->execute($params);
        return $sql->fetchAll();
    }

}

